SystemOrganization addCategory: #'Metacello-MC-Loaders'!
SystemOrganization addCategory: #'Metacello-MC-Model'!
SystemOrganization addCategory: #'Metacello-MC-Specs'!
SystemOrganization addCategory: #'Metacello-MC-Validation'!
SystemOrganization addCategory: #'Metacello-Platform'!

AnObsoleteMetacelloMemberListSpec subclass: #MetacelloRepositoriesSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 10/3/2009 16:52'!
add: aStringOrSpec

	aStringOrSpec addToMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 10:18'!
add: description type: type

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			type: type;
			yourself.
	self addMember: 
		(self addMember 
			name: spec name;
			spec: spec;
			yourself)! !

!MetacelloRepositoriesSpec methodsFor: 'printing' stamp: 'DaleHenrichs 11/10/2010 16:13'!
configMethodCascadeOn: aStream indent: indent

	| repositorySpecs |
	repositorySpecs := self map values sort: [:a :b | a description <= b description ].
	repositorySpecs size = 1
		ifTrue: [ repositorySpecs first configMethodCascadeOn: aStream lastCascade: true ]
		ifFalse: [
			1 to: repositorySpecs size do: [:index | | repositorySpec |
				aStream tab: indent + 1.
				(repositorySpecs at: index)
					configMethodCascadeOn: aStream 
					lastCascade: index >= repositorySpecs size ]]! !

!MetacelloRepositoriesSpec methodsFor: 'printing' stamp: 'dkh 1/2/2010 17:11'!
configMethodOn: aStream indent: indent

	aStream 
		tab: indent; 
		nextPutAll: 'spec';
		cr.
	self configMethodCascadeOn: aStream indent: indent! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 10:18'!
merge: aRepositorySpec

	aRepositorySpec mergeIntoMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 20:50'!
merge: description type: type

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			type: type;
			yourself.
	self addMember: 
		(self mergeMember 
			name: spec name;
			spec: spec;
			yourself)! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 10:22'!
remove: aRepositorySpec

	aRepositorySpec removeFromMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 10/6/2009 23:59'!
repository: aStringOrSpec

	aStringOrSpec addToMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 10/22/2009 09:01'!
repository: description username: username password: password

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			username: username;
			password: password;
			yourself.
	self addMember: 
		(self addMember 
			name: spec name;
			spec: spec;
			yourself)! !

AnObsoleteMetacelloAbstractPackageSpec subclass: #MetacelloPackageSpec
	instanceVariableNames: 'file repositories goferPackage preLoadDoIt postLoadDoIt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 3/20/2011 17:45'!
ancestors

	^self goferPackage ancestors! !

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 11:36'!
compareCurrentVersion: anOperator targetVersionStatus: statusIgnored using: anMCLoader

	self 
		currentPackageLoaded: [:bool | ^bool ] 
		comparing: anOperator 
		notLoaded: [:ignored | ^false ]
		using: anMCLoader
! !

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 14:03'!
compareRelativeCurrentVersion: anOperator targetVersionStatus: statusIgnored using: anMCLoader

	^self compareCurrentVersion: anOperator targetVersionStatus: statusIgnored using: anMCLoader
! !

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'dkh 3/3/2011 07:56'!
compareWorkingCopyNamed: wcName using: comarisonOperator
	| fileRef wcRef |
	fileRef := GoferResolvedReference name: self file.
	wcRef := GoferResolvedReference name: wcName.
	^ wcRef compare: fileRef using: comarisonOperator! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'DaleHenrichs 1/14/2011 15:02'!
configMethodBodyOn: aStream hasName: hasName indent: indent

	| hasFile hasRepositories hasPreLoadDoIt hasPostLoadDoIt hasRequiresOrIncludesOrAnswers |
	hasFile := file ~~ nil.
	hasRepositories := self repositorySpecs size > 0.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	hasRequiresOrIncludesOrAnswers := (self requires isEmpty and: [ self includes isEmpty and: [self answers isEmpty ]]) not.
	hasRequiresOrIncludesOrAnswers
		ifTrue: [ 
			self 
				configMethodBodyOn: aStream 
				hasName: hasName 
				cascading: hasFile | hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt
				indent: indent ].
	self 
		configMethodOn: aStream 
		for: file 
		selector: 'file: ' 
		cascading: hasName | hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers 
		cascade: hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt 
		indent: indent.
	hasRepositories
		ifTrue: [ 
			(self repositorySpecs size > 1)
				ifTrue: [ 
					hasName | hasFile | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
						ifTrue: [ 
							aStream cr;
							tab: indent. ].
					aStream 
						nextPutAll: 'repositories: ['; 
						cr;
						tab: indent + 1;
						nextPutAll: 'spec'; 
						cr.
					self repositories configMethodCascadeOn: aStream indent: indent + 1.
					aStream nextPutAll: ' ]' ]
				ifFalse: [ 
					hasName | hasFile | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
						ifTrue: [ aStream cr; tab: indent ].
					self repositories configMethodCascadeOn: aStream indent: indent ].
			hasPreLoadDoIt | hasPostLoadDoIt ifTrue: [ aStream nextPut: $; ] ].
	self 
		configMethodOn: aStream 
		for: self getPreLoadDoIt 
		selector: 'preLoadDoIt: '
		cascading: hasName | hasFile | hasRepositories | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers 
		cascade: hasPostLoadDoIt 
		indent: indent.
	self 
		configMethodOn: aStream 
		for: self getPostLoadDoIt 
		selector: 'postLoadDoIt: ' 
		cascading: hasName | hasFile | hasRepositories | hasPreLoadDoIt | hasRequiresOrIncludesOrAnswers 
		cascade: false 
		indent: indent.
	aStream nextPut: $.! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'dkh 10/7/2009 09:36'!
configMethodCascadeOn: aStream member: aMember last: lastCascade indent: indent

	aMember methodUpdateSelector  == #remove:
		ifTrue: [ aStream  nextPutAll: 'removePackage: ', self name printString ]
		ifFalse: [ self configShortCutMethodBodyOn: aStream member: aMember indent: indent ].
	lastCascade
		ifTrue: [ aStream nextPut: $. ]
		ifFalse: [ aStream nextPut: $;; cr ]! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/21/2010 13:46'!
configMethodOn: aStream indent: indent

	| hasRepositories hasPreLoadDoIt hasPostLoadDoIt hasRequiresOrIncludesOrAnswers hasFile |
	hasFile := file ~~ nil.
	hasRepositories := self repositorySpecs size > 0.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	hasRequiresOrIncludesOrAnswers := (self requires isEmpty and: [ self includes isEmpty and: [self answers isEmpty ]]) not.
	aStream tab: indent; nextPutAll: 'spec '.
	hasFile | hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
		ifTrue: [
			aStream cr; tab: indent + 1; nextPutAll: 'name: ', self name printString; nextPut: $;.
			self configMethodBodyOn: aStream hasName: true indent: indent + 1 ]
		ifFalse: [
			aStream nextPutAll: 'name: ', self name printString ]! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/21/2010 13:46'!
configShortCutMethodBodyOn: aStream member: aMember indent: indent

	| hasFile hasRepositories hasPreLoadDoIt hasPostLoadDoIt hasRequiresOrIncludesOrAnswers |
	hasFile := file ~~ nil.
	hasRepositories := self repositorySpecs size > 0.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	hasRequiresOrIncludesOrAnswers := (self requires isEmpty and: [ self includes isEmpty and: [self answers isEmpty ]]) not.
	hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
		ifTrue: [
			aStream 
				nextPutAll: 'package: ', self name printString, ' ';
				nextPutAll: aMember methodUpdateSelector asString, ' ['; cr.
			aStream tab: indent + 1; nextPutAll: 'spec '.
			self configMethodBodyOn: aStream hasName: false indent: indent + 2.
			aStream nextPutAll: ' ]'.
			^self ].
	aStream nextPutAll: 'package: ', self name printString.
	hasFile
		ifTrue: [ aStream nextPutAll: ' with: ', file printString ]! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 12/6/2010 13:14'!
copySpecTo: aRepositorySpec
	"Copy current mcz file to the repository named in aRepositorySpec"

	self loader copySpec: self from: self repositorySpecs to: aRepositorySpec createRepository! !

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'dkh 3/20/2011 17:56'!
currentPackageLoaded: loadedBlock comparing: comarisonOperator notLoaded: notLoadedBlock using: anMCLoader
	"Use currentVersionInfoFor: because it involves the loader and returns versionInfo for a planned load 
	 (atomic loaders) or currently loaded package"

	| wcName vis |
	vis := anMCLoader ancestorsFor: self.
	vis notNil
		ifTrue: [ 
			| fileRef wcRef |
			self getFile == nil
				ifTrue: [ ^ loadedBlock value: false ].
			vis
				do: [ :vi | 
					wcName := vi name.
					fileRef := GoferResolvedReference name: self file.
					wcRef := GoferResolvedReference name: wcName.
					(wcRef compare: fileRef using: comarisonOperator)
						ifTrue: [ ^ loadedBlock value: true ] ].
			^ loadedBlock value: false ].
	^ notLoadedBlock value: true! !

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'dkh 7/8/2011 21:40'!
currentPackageLoaded: loadedBlock notLoaded: notLoadedBlock using: anMCLoader
	"Use currentVersionInfoFor: because it involves the loader and returns versionInfo for a planned load 
	 (atomic loaders) or currently loaded package"

	| wcName vis |
	vis := anMCLoader ancestorsFor: self.
	vis notNil
		ifTrue: [ 
			self getFile == nil
				ifTrue: [ ^ loadedBlock value: #() value: self file ].
			^ loadedBlock value: vis value: self file ].
	^ notLoadedBlock value! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 9/25/2009 11:26'!
currentVersionInfo

	^self goferPackage currentVersionInfo! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/5/2010 19:05'!
ensureLoadedForDevelopmentUsing: mcLoader
	"noop"
	
	^true! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'dkh 11/16/2011 14:13'!
explicitLoadUsing: mcLoader

	| wc fetchingSpecLoader |
	((wc := self workingCopy) ~~ nil and: [ wc needsSaving ]) 
		ifTrue: [ 
			(MetacelloSkipDirtyPackageLoad signal: self)
				ifTrue:  [
					Transcript cr; show: 'Skipping load of modified package: ', self file.
					^self]
				ifFalse: [Transcript cr; show: 'Load over modified package: ', self file] ].
	"fetch and explicitly load it"
	fetchingSpecLoader := mcLoader fetchingSpecLoader.
	fetchingSpecLoader
		explicitLoadPackageSpecs: (Array with: self) 
		repositories: (fetchingSpecLoader repositoriesFrom: self repositorySpecs).
! !

!MetacelloPackageSpec methodsFor: 'private' stamp: 'dkh 10/7/2009 01:09'!
extractNameFromFile

	file == nil ifTrue: [ ^nil ].
	^(self loader nameComponentsFrom: self file) first! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/7/2010 09:36'!
fetch

	self fetchUsing: self loader! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 4/12/2010 13:57'!
fetchPackage: aLoaderPolicy

	self fetchUsing: 
		(self loader
			loaderPolicy: aLoaderPolicy;
			yourself)! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/7/2010 09:38'!
fetchUsing: mcLoader

	| fetchingSpecLoader |
	fetchingSpecLoader := mcLoader fetchingSpecLoader.
	fetchingSpecLoader
		linearLoadPackageSpecs: (Array with: self) 
		repositories: (fetchingSpecLoader repositoriesFrom: self repositorySpecs).
! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 10/6/2009 15:12'!
file

	file == nil ifTrue: [ ^self name ].
	^file
! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 06/03/2009 12:11'!
file: aString

	file := aString! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/12/2010 06:33'!
forceUpdatePackageSpec: updatedSpecs using: anMCLoader
	
	self updatePackageSpec: updatedSpecs force: true using: anMCLoader! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 10/30/2009 10:37'!
getFile
	"raw access to iv"
	
	^file! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'DaleHenrichs 12/21/2010 13:44'!
getPostLoadDoIt

	^postLoadDoIt! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'DaleHenrichs 12/21/2010 13:44'!
getPreLoadDoIt

	^preLoadDoIt! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'dkh 4/17/2011 14:41'!
goferBranchPackage: branchName message: commitMessage
	"uses gofer to do commit ... non-interactive"

	| latestFile pkgSpec   |
	(file notNil and: [ (self name, '.', branchName) = self file ])
		ifTrue: [ 
			latestFile := self loader latestPackage: self file fromRepository: self repositorySpecs.
			pkgSpec := self copy.
			latestFile ~~ nil
				ifTrue: [ 
					pkgSpec file: latestFile.
					pkgSpec goferCommitPackage: commitMessage.
					^ self ] ].
	self loader goferCommitBranchPackage: branchName using: self repositorySpecs commitMessage: commitMessage! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 3/15/2010 11:38'!
goferCommitPackage: commitMessage
	"uses gofer to do commit ... non-interactive"
	
	| latestFile pkgSpec |
	^(file notNil and: [ self name = self file ])
		ifTrue: [
			latestFile := self loader latestPackage: self name fromRepository: self repositorySpecs.
			pkgSpec := self copy.
			pkgSpec file: latestFile.
			pkgSpec goferCommitPackage: commitMessage ]
		ifFalse: [ self loader goferCommitPackageUsing: self repositorySpecs commitMessage: commitMessage ]
! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/13/2010 17:04'!
goferLoaderReference

	^file == nil 
		ifTrue: [ GoferPackageReference name: self name ]
		ifFalse: [ 
			"does Monticello-style #versionInfoFromVersionNamed: matching"
			MetacelloGoferPackage name: self name packageFilename: self file ]! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 12/15/2009 10:32'!
goferPackage

	goferPackage == nil 
		ifTrue: [ goferPackage := MetacelloGoferPackage name: self name packageFilename: self file ].
	^goferPackage! !

!MetacelloPackageSpec methodsFor: 'private' stamp: 'dkh 10/10/2009 11:00'!
includesForPackageOrdering

	^self includes! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/6/2010 17:58'!
info
	"test compatibility method"

	^self! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 5/14/2010 15:50'!
isPackageLoaded

	^self isPackageLoaded: self loader! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 5/14/2010 15:50'!
isPackageLoaded: aLoader

	^(self workingCopyNameFor: aLoader) ~~ nil! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/6/2010 10:28'!
load

	self explicitLoadUsing: self loader! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/10/2010 12:32'!
loadUsing: mcLoader

	self loader doingLoads: [ self explicitLoadUsing: mcLoader ]
! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 4/9/2010 12:29'!
loadUsing: aLoader gofer: gofer

	^aLoader linearLoadPackageSpec: self gofer: gofer! !

!MetacelloPackageSpec methodsFor: 'merging' stamp: 'DaleHenrichs 1/21/2010 20:37'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #file put: file.
	map at: #repositories put: self repositories.
	map at: #preLoadDoIt put: preLoadDoIt.
	map at: #postLoadDoIt put: postLoadDoIt.
	^map! !

!MetacelloPackageSpec methodsFor: 'merging' stamp: 'Dalehenrichs 02/10/2010 10:54'!
mergeSpec: anotherSpec

	| newSpec map anotherPackages anotherRepositories |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherRepositories := map at: #repositories) notEmpty
		ifTrue: [ 
			newSpec 
				repositories: (self repositories isEmpty
					ifTrue: [ anotherRepositories ]
					ifFalse: [ self repositories mergeSpec: anotherRepositories ]) ].
	^newSpec! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 06/03/2009 12:13'!
name

	name == nil ifTrue: [ name := self extractNameFromFile ].
	^name! !

!MetacelloPackageSpec methodsFor: 'merging' stamp: 'dkh 1/2/2010 16:29'!
nonOverridable

	^super nonOverridable, #( repositories)! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:35'!
packageRepository
	
	self repositorySpecs isEmpty ifTrue: [ ^nil ].
	^self repositorySpecs first! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'dkh 6/8/2009 16:16'!
packageSpecsInLoadOrder

	^{ self. }! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'dkh 12/22/2009 10:17'!
packagesNeedSavingVisited: visitedProjects using: repos into: aCollection

	^self loader packagesNeedSavingUsing: repos into: aCollection! !

!MetacelloPackageSpec methodsFor: 'copying' stamp: 'dkh 1/2/2010 15:46'!
postCopy

	super postCopy.
	goferPackage := nil.
	repositories := repositories copy.
! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 20:40'!
postLoadDoIt

	^postLoadDoIt! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:57'!
postLoadDoIt: anObject

	anObject setPostLoadDoItInMetacelloSpec: self! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 20:40'!
preLoadDoIt

	^preLoadDoIt! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:57'!
preLoadDoIt: anObject

	anObject setPreLoadDoItInMetacelloSpec: self! !

!MetacelloPackageSpec methodsFor: 'visiting' stamp: 'dkh 10/5/2009 09:39'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	packageBlock value: self! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:41'!
repositories

	repositories == nil ifTrue: [ repositories := self project repositoriesSpec ].
	^ repositories! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:41'!
repositories: anObject
	repositories := anObject! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:46'!
repository

	self deprecated: 'Use repositories or repositorySpecs'.
	^self packageRepository! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/2/2010 15:44'!
repository: aStringOrMetacelloRepositorySpec

	self repositories repository: aStringOrMetacelloRepositorySpec! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/2/2010 15:47'!
repository: aString username: username password: password

	self repositories repository: aString username: username password: password! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'dkh 1/2/2010 15:43'!
repositorySpecs

	^self repositories map values ! !

!MetacelloPackageSpec methodsFor: 'private' stamp: 'dkh 10/21/2009 15:22'!
resolveToPackagesIn: aVersionSpec visited: visited

	^{ self }
! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 3/15/2010 11:35'!
savePackage
	"Interactive save ... prompted for commit message and package name unless MCVersionNameAndMessageRequest handled"

	| latestFile pkgSpec |
	^(file notNil and: [ self name = self file ])
		ifTrue: [
			latestFile := self loader latestPackage: self name fromRepository: self repositorySpecs.
			pkgSpec := self copy.
			pkgSpec file: latestFile.
			pkgSpec savePackage ]
		ifFalse: [ self loader savePackageUsing: self repositorySpecs ]
! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:53'!
setPostLoadDoIt: aSymbol

	postLoadDoIt := aSymbol! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 12/21/2010 13:53'!
setPreLoadDoIt: aSymbol

	preLoadDoIt := aSymbol! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/16/2010 16:31'!
updateForSpawnMethod: sourceSpec
	"This means that this spec was used in a baseline and will be used in a version .... drop all information that isn't useful"

	| nm fl |
	nm := name.
	fl := file.
	sourceSpec ~~ nil ifTrue: [ fl := sourceSpec file ].
	super updateForSpawnMethod: sourceSpec.
	file := repositories := goferPackage := preLoadDoIt := postLoadDoIt := nil.
	name := nm.
	file := fl.! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'dkh 01/14/2010 12:57'!
updatePackageRepositories: repositorySpecs

	| resolvedPackageRef |
	Transcript cr; show: '  Looking up version -> ', self file.
	resolvedPackageRef := self loader resolveSpec: self from: repositorySpecs.
	Transcript cr; show: 'Update repositoryGroup -> ', resolvedPackageRef name, ' ' , resolvedPackageRef repository description.
	resolvedPackageRef version workingCopy repositoryGroup addRepository: resolvedPackageRef repository
! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'dkh 11/01/2009 11:15'!
updatePackageRepositoriesFor: aVersionSpec
	"Don't update the repository unless the package is loaded in the image"
	
	self workingCopy == nil ifTrue: [ ^self ].
	self updatePackageRepositories: self repositorySpecs, aVersionSpec repositorySpecs.	
! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/12/2010 14:56'!
updatePackageSpec: updatedSpecs force: force using: anMCLoader
	"Add pkg copy to updatedSpecs if the file in current image is different from the receiver's file"

	| viName |
	(force not and: [ self getFile == nil ])
		ifTrue: [ ^ self ].	"no file explicitly specified in this spec"
	(viName := self workingCopyNameFor: anMCLoader) == nil
		ifTrue: [ ^ self ].	"no working copy"
	viName ~= self file
		ifTrue: [ 
			| spec |
			spec := self copy.
			spec file: viName.
			updatedSpecs at: spec name put: spec ]
		ifFalse: [ updatedSpecs at: self name put: #uptodate ]! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/12/2010 06:33'!
updatePackageSpec: updatedSpecs using: anMCLoader
	"Add pkg copy to updatedSpecs if the file in current image is different from the receiver's file"
	
	self updatePackageSpec: updatedSpecs force: false using: anMCLoader! !

!MetacelloPackageSpec methodsFor: 'visiting' stamp: 'dkh 10/21/2009 15:51'!
visitingWithPackages: packages

	packages at: self name put: self! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 9/25/2009 10:53'!
workingCopy

	^self goferPackage workingCopy! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 11/05/2009 13:58'!
workingCopyName

	| wc |
	(wc := self workingCopy) == nil ifTrue: [ ^nil ].
	wc ancestry ancestors isEmpty not
		ifTrue: [ ^wc ancestry ancestors first name ].
	^nil! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 9/25/2009 10:52'!
workingCopyNameFor: anMCLoader

	| vi |
	(vi := anMCLoader currentVersionInfoFor: self) == nil ifTrue: [ ^nil ].
	^vi name! !

AnObsoleteMetacelloPlatform subclass: #MetacelloPharoPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-Platform'!

!MetacelloPharoPlatform class methodsFor: 'initialize-release' stamp: 'dkh 8/20/2009 15:33'!
initialize
	"implmented to force initialize on load"
	
	super initialize! !

!MetacelloPharoPlatform methodsFor: 'utilities' stamp: 'dkh 10/7/2009 10:54'!
authorName

	^Author fullName! !

!MetacelloPharoPlatform methodsFor: 'utilities' stamp: 'DaleHenrichs 1/5/2011 16:59'!
authorName: aString

	Author fullName: aString! !

!MetacelloPharoPlatform methodsFor: 'notification' stamp: 'DaleHenrichs 3/11/2010 19:28'!
collection: aCollection do: aBlock displaying: aString

	self bypassProgressBars ifTrue: [ ^super collection: aCollection do: aBlock displaying: aString ].
	aCollection 
		do: aBlock
		displayingProgress: aString! !

!MetacelloPharoPlatform methodsFor: 'reflection' stamp: 'DaleHenrichs 1/5/2011 16:26'!
copyClass: oldClass as: newName inCategory: newCategoryName
	| copysName class newDefinition |
	copysName := newName asSymbol.
	copysName = oldClass name
		ifTrue: [ ^ oldClass ].
	(Smalltalk includesKey: copysName)
		ifTrue: [ ^ self error: copysName , ' already exists' ].
	newDefinition := oldClass definition copyReplaceAll: '#' , oldClass name asString with: '#' , copysName asString printString.
	newDefinition := newDefinition
		copyReplaceAll: 'category: ' , (SystemOrganization categoryOfElement: oldClass name) asString printString
		with: 'category: ' , newCategoryName printString.
	class := Compiler evaluate: newDefinition logged: true.
	class class instanceVariableNames: oldClass class instanceVariablesString.
	class copyAllCategoriesFrom: oldClass.
	class class copyAllCategoriesFrom: oldClass class.
	class category: newCategoryName.
	^ class! !

!MetacelloPharoPlatform methodsFor: 'repository creation' stamp: 'dkh 12/7/2009 14:48'!
createRepository: aRepositorySpec

	| type |
	type := aRepositorySpec type.
	type = 'ftp'
		ifTrue: [ | description headerSize index host directory |
			description := aRepositorySpec description.
			headerSize := 'ftp://' size.
			index := description indexOf: $/ startingAt: headerSize + 1.
			host := description copyFrom: headerSize + 1 to: index - 1.
			directory := description copyFrom: index + 1 to: description size.
			^ MCFtpRepository
				host: host 
				directory: directory 
				user: aRepositorySpec username
				password: aRepositorySpec password].
	^ super createRepository: aRepositorySpec! !

!MetacelloPharoPlatform methodsFor: 'attributes' stamp: 'dkh 9/8/2011 14:48'!
defaultPlatformAttributes
	| attributes versionString |
	((Smalltalk respondsTo: #image) and: [ Smalltalk image respondsTo: #metacelloPlatformAttributes ])
		ifTrue: [ ^ Smalltalk image metacelloPlatformAttributes ].
	attributes := OrderedCollection with: #squeakCommon with: #pharo.
	Smalltalk
		at: #SystemVersion
		ifPresent: [ :cl | 
			versionString := cl current version.
			(((versionString beginsWith: 'Pharo-1') or: [ versionString beginsWith: 'PharoCore1' ])
				or: [ versionString beginsWith: 'Pharo1' ])
				ifTrue: [ 
					attributes add: #'pharo1.x'.
					((versionString beginsWith: 'Pharo-1.0') or: [ versionString beginsWith: 'PharoCore1.0' ])
						ifTrue: [ attributes add: #'pharo1.0.x' ]
						ifFalse: [ 
							((versionString beginsWith: 'Pharo-1.1') or: [ versionString beginsWith: 'Pharo1.1' ])
								ifTrue: [ attributes add: #'pharo1.1.x' ]
								ifFalse: [ 
									((versionString beginsWith: 'Pharo-1.2') or: [ versionString beginsWith: 'Pharo1.2' ])
										ifTrue: [ attributes add: #'pharo1.2.x' ]
										ifFalse: [ 
											(versionString beginsWith: 'Pharo1.3')
												ifTrue: [ attributes add: #'pharo1.3.x' ] ] ] ] ] ].
	^ attributes! !

!MetacelloPharoPlatform methodsFor: 'notification' stamp: 'DaleHenrichs 3/11/2010 20:02'!
do: aBlock displaying: aString

	self bypassProgressBars ifTrue: [ ^super do: aBlock displaying: aString ].
	aString
		displayProgressAt: Sensor cursorPoint
		from: 0 to: 2
		during: [:bar |
			bar value: 1.
			aBlock value.
			bar value: 2 ]! !

!MetacelloPharoPlatform methodsFor: 'repository creation' stamp: 'dkh 12/7/2009 14:07'!
extractTypeFromDescription: description

	(description beginsWith: 'ftp://') ifTrue: [ ^'ftp' ].
	^super extractTypeFromDescription: description! !

!MetacelloPharoPlatform methodsFor: 'utilities' stamp: 'dkh 10/7/2009 11:01'!
timestamp

	^Date today mmddyyyy, ' ',
		((String streamContents: [:s | Time now print24: true on: s]) copyFrom: 1 to: 5)! !

AnObsoleteMetacelloProjectSpec subclass: #MetacelloMCProjectSpec
	instanceVariableNames: 'projectPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 7/20/2011 11:51'!
className: aString

	super className: aString.
	(projectPackage ~~ nil and: [ projectPackage getFile == nil ])
		ifTrue: [ projectPackage name: aString; file: aString ]! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'DaleHenrichs 11/5/2010 15:55'!
compareCurrentVersion: anOperator targetVersionStatus: targetVersionStatus using: anMCLoader

	| cv vrsn prjct |
	(vrsn := self versionOrNil) == nil ifTrue: [ ^false ].
	prjct := self projectClassProject.
	prjct loader: anMCLoader.
	(cv := prjct currentVersion) == nil ifTrue: [ ^false ].
	(targetVersionStatus includes: cv versionStatus)
		ifTrue: [ ^cv perform: anOperator with: vrsn ].
	^false
	
 ! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'DaleHenrichs 11/5/2010 15:55'!
compareRelativeCurrentVersion: anOperator targetVersionStatus: targetVersionStatus using: anMCLoader

	| cv vrsn |
	(vrsn := self versionOrNil) == nil ifTrue: [ ^false ].
	(cv := self relativeCurrentVersion) == nil ifTrue: [ ^false ].
	(targetVersionStatus includes: cv versionStatus)
		ifTrue: [ ^cv perform: anOperator with: vrsn ].
	^false
	
 ! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 11/5/2010 15:56'!
determineCurrentVersionForLoad
	"don't use self currentVersion, because we are interested in the currentVersion of the project as loaded in image, not the current version relative to our load list"
	
	| prjct version currentVersion packageAndProjectNames cvs |
	self projectClass == nil ifTrue: [ ^nil ].
	(version := self versionOrNil) == nil ifTrue: [ ^nil ].
	version blessing == #baseline ifTrue: [ ^version ].
	self loader ignoreImage ifTrue: [ ^version ].
	prjct := self projectClass new project.
	prjct loader: self loader.
	(currentVersion := prjct currentVersion) == nil ifTrue: [ ^nil ].
	(cvs := currentVersion versionStatus) == #somethingLoaded ifTrue: [ ^nil ].
	(#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: (cvs := currentVersion versionStatus)) 
		ifTrue: [ 
			(currentVersion perform: self operator with: version)
				ifTrue: [ "load currentVersion" ^currentVersion ].
			"load version" ^nil ].
	version = currentVersion ifTrue: [ ^currentVersion ].
	(MetacelloProjectSpecLoadConflict projectSpec: self) 
		signal: 
			'Project load conflict for', 
			prjct label printString,  
			' between current version ',
			currentVersion printString, 
			'(', 
			cvs asString, 
			') and specified version ', 
			version printString,
			'. Press resume to continue with load anyway'.
	^nil! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'dkh 9/7/2011 14:17'!
ensureLoadedForDevelopmentUsing: mcLoader
	"for #development projects, always need latest version of package when contemplating a load"

	| ensured |
	ensured := mcLoader ensuredMap at: self name ifAbsent: [ nil ].
	self projectClass ~~ nil
		ifTrue: [  | vrsn |
			vrsn := self versionOrNil.
			(vrsn ~~ nil and: [ vrsn blessing == #development ])
				ifTrue: [ 
					ensured ~~ #latest
						ifTrue: [
							mcLoader ensureForDevelopment
								ifTrue: [  | pc |
									(pc := self projectClass) ~~ nil
										ifTrue: [ MetacelloClearStackCacheNotification signal: #(#versionConstructor)].
									self projectPackage loadUsing: mcLoader ]
								ifFalse: [ self projectPackage fetchUsing: mcLoader ].
							mcLoader ensuredMap at: self name put: #latest ].
					^self]].
	ensured == nil
		ifTrue:  [
			mcLoader ensureForDevelopment
				ifTrue: [  | pc |
					(pc := self projectClass) ~~ nil
						ifTrue: [ MetacelloClearStackCacheNotification signal: #(#versionConstructor)]. 
					self projectPackage loadUsing: mcLoader ]
				ifFalse: [ self projectPackage fetchUsing: mcLoader ].
			mcLoader ensuredMap at: self name put: #present ]! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'dkh 9/7/2011 14:13'!
ensureProjectLoaded
	"Ensure that the MetacelloProject is loaded in image. 
	 projectClass == nil or requested version non-existent warrants a project package load."

	(self projectClass == nil or: [ self versionOrNil == nil ])
		ifTrue: [ | pc |
			(pc := self projectClass) ~~ nil
				ifTrue: [ MetacelloClearStackCacheNotification signal: #(#versionConstructor)].
			self projectPackage load.
			^ true ].
	^ false! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 10/24/2009 20:19'!
file
	
	^self projectPackage file! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 7/20/2011 11:54'!
file: aString
	self projectPackage name ifNil: [ self projectPackage name: aString ].
	self projectPackage file: aString! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'DaleHenrichs 12/21/2010 13:45'!
hasNonVersionStringField
	| hasVersionString hasOperator hasProjectPackage hasLoads hasClassName hasPreLoadDoIt hasPostLoadDoIt |
	hasClassName := self className ~~ nil.
	hasVersionString := self versionString ~~ nil.
	hasOperator := operator ~~ nil.
	hasProjectPackage := self projectPackage ~~ nil
		and: [ self projectPackage name ~~ nil or: [ self projectPackage packageRepository ~~ nil ] ].
	hasLoads := self loads ~~ nil.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	^ hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'DaleHenrichs 11/5/2010 15:56'!
isPartiallyLoaded: aLoader

	| vrsn |
	(vrsn := self versionOrNil) == nil ifTrue: [ ^false ].
	(self loadListForVersion: vrsn) do: [:nm |
		(vrsn packagesForSpecNamed: nm ) do: [:pkg |
			(pkg isPackageLoaded: aLoader) ifTrue: [ ^true ]]].
	^false! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'DaleHenrichs 11/5/2010 15:56'!
isPossibleBaseline

	| vrsn |
	(vrsn := self versionOrNil) == nil ifTrue: [ ^false ].
	(vrsn allPackagesForSpecNamed: (self loadListForVersion: vrsn)) do: [:pkg |
		pkg workingCopy == nil ifTrue: [ ^false ]].
	^true! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 10/25/2010 15:32'!
load

	| displayString |
	displayString := 'Project: ', self name.
	self versionString ~~ nil ifTrue: [ displayString := displayString, ' ', self versionString ].
	Transcript cr; show: displayString.
	self ensureProjectLoaded.
	self loadVersion: self determineCurrentVersionForLoad! !

!MetacelloMCProjectSpec methodsFor: 'private' stamp: 'dkh 10/21/2009 19:20'!
loadListForVersion: vrsn 

	^ (self loads == nil
			or: [self loads isEmpty])
		ifTrue: [vrsn spec defaultPackageNames]
		ifFalse: [self loads]! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 15:57'!
loadPackageList

	| vrsn pkgs |
	(vrsn := self versionOrNil) == nil ifTrue: [ ^#() ].
	pkgs := OrderedCollection new.
	(self loadListForVersion: vrsn) do: [:nm |
		pkgs addAll: ((vrsn packagesForSpecNamed: nm ) collect: [:each | each name ])].
	^pkgs! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 11/5/2010 15:57'!
loadVersion: aVersionOrNil
	"Load the correct version of the project"

	| vrsn mcLoader list |
	vrsn := aVersionOrNil .
	vrsn == nil
		ifTrue: [ 
			(vrsn := self versionOrNil) == nil
				ifTrue: [
					 ^(MetacelloProjectSpecLoadError projectSpec: self) 
						signal: 'No version found for ', 
									self versionString printString, 
									' of ', 
									self className asString ]].
	mcLoader := self loader copy.
	mcLoader operator: self operator.
	vrsn loader: mcLoader.
	list := (mcLoader ignoreImage 
		ifTrue: [ self loadListForVersion: vrsn ]
		ifFalse: [ vrsn packageAndProjectNamesToLoad: (self loadListForVersion: vrsn) loader: mcLoader ]) asSet.
	MetacelloPlatform current 
		useStackCacheDuring: [:dict | | projectCache cachedList |
			projectCache := dict 
					at: self projectClass 
					ifAbsent: [ dict at: self projectClass put: Dictionary new].
			(cachedList := projectCache at: vrsn ifAbsent: []) == nil
				ifTrue: [  projectCache at: vrsn put: list ]
				ifFalse: [ 
					(cachedList size = list size and: [ cachedList includesAllOf: list ]) 
						ifTrue: [ 
							"no need to refetch list ... recursion stoppper (Issue 95)" 
							^self ]
						ifFalse: [  projectCache at: vrsn put: list ]].
			mcLoader preLoad: self.
			vrsn fetchRequiredFromArray: list.
			mcLoader postLoad: self.
			] 
		defaultDictionary: Dictionary new.
! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 15:57'!
loadedPackageNames: aLoader

	| vrsn pkgs |
	(vrsn := self versionOrNil) == nil ifTrue: [ ^#() ].
	pkgs := OrderedCollection new.
	(self loadListForVersion: vrsn) do: [:nm |
		(vrsn packagesForSpecNamed: nm ) do: [:pkg |
			(pkg isPackageLoaded: aLoader) ifTrue: [ pkgs add: pkg name ]]].
	^pkgs! !

!MetacelloMCProjectSpec methodsFor: 'merging' stamp: 'dkh 10/4/2009 12:05'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #projectPackage put: projectPackage.
	^map! !

!MetacelloMCProjectSpec methodsFor: 'merging' stamp: 'dkh 10/9/2009 06:28'!
mergeSpec: anotherSpec

	| newSpec anotherProjectPackage map |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherProjectPackage := map at: #projectPackage) ~~ nil
		ifTrue: [ 
			newSpec projectPackage: 
				(newSpec projectPackage == nil
					ifTrue: [ anotherProjectPackage ]
					ifFalse: [ newSpec projectPackage mergeSpec: anotherProjectPackage ])].
	^newSpec! !

!MetacelloMCProjectSpec methodsFor: 'merging' stamp: 'dkh 10/8/2009 20:34'!
nonOverridable

	^super nonOverridable, #( projectPackage )! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 11:44'!
packageFileSpecFor: aMetacelloPackagesSpec

	^(aMetacelloPackagesSpec project projectReferenceSpec)
			name: self name;
			projectReference: self copy;
			yourself.
! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 11/12/2009 16:56'!
packageRepository
	
	^nil! !

!MetacelloMCProjectSpec methodsFor: 'copying' stamp: 'DaleHenrichs 11/17/2010 12:44'!
postCopy

	super postCopy.
	projectPackage := projectPackage copy.
! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 11/11/2010 17:07'!
projectClass

	self className == nil ifTrue: [ ^nil ].
	^Smalltalk at: self className asSymbol  ifAbsent: []! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 9/10/2009 13:18'!
projectClassProject
	"indirection needed when projectClass is _not_ a subclass of MetacelloProject"
	
	^self projectClass new project! !

!MetacelloMCProjectSpec methodsFor: 'visiting' stamp: 'dkh 10/21/2009 15:53'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	projectBlock value: self! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 6/7/2009 09:19'!
projectPackage
	^ projectPackage! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 6/7/2009 09:19'!
projectPackage: anObject
	projectPackage := anObject! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 7/8/2011 22:27'!
relativeCurrentVersion
	"currentVersion calculated relative to the loadList"
	
	| vrsn expanded loadList |
	(vrsn := self versionOrNil) == nil ifTrue: [ ^nil ].
	expanded := [ vrsn expandToLoadableSpecNames: (loadList := self loadListForVersion: vrsn) ] 
					on: Error 
					do: [:ex |
						vrsn blessing == #development
							ifTrue: [ 
								self projectPackage load.
								vrsn := self versionOrNil.
								ex return: (vrsn expandToLoadableSpecNames: loadList)].
						ex pass].
	^self projectClassProject currentVersionAgainst: expanded
		! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:36'!
repository
	
	^self projectPackage packageRepository! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/7/2009 01:02'!
repository: aString

	self projectPackage repository: aString! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 09:39'!
repository: aString username: username password: password

	self projectPackage repository: aString username: username password: password! !

!MetacelloMCProjectSpec methodsFor: 'private' stamp: 'DaleHenrichs 11/5/2010 15:57'!
resolveToAllPackagesIn: aVersionSpec visited: visited
	| vrsn |
	visited
		pushProject: [ 
			visited
				visit: self
				doing: [ :spec | 
					spec ensureProjectLoaded.
					(vrsn := spec versionOrNil) == nil
						ifTrue: [ (MetacelloVersionDoesNotExistError project: self project versionString: self versionString) signal ].
					^ vrsn allPackagesForSpecNamed: (self loadListForVersion: vrsn) ifAbsent: [ self error: 'invalid loads: spec' ] ] ].
	^ #()! !

!MetacelloMCProjectSpec methodsFor: 'private' stamp: 'dkh 11/12/2009 10:12'!
resolveToLoadableSpec

	^self copy! !

!MetacelloMCProjectSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/16/2010 16:31'!
updateForSpawnMethod: sourceSpec
	"This means that this spec was used in a baseline and will be used in a version .... drop all information that isn't useful"
	
	className := operator := loads := projectPackage := nil.
	sourceSpec ~~ nil ifTrue: [ versionString := sourceSpec versionString ].! !

!MetacelloMCProjectSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/5/2010 15:57'!
updatePackageSpec: updatedSpecs
	"Add project copy to updatedSpecs if the current version of the project 
	 is different from the receiver's version"
	
	|  prj currentVersion spec |
	self className == nil ifTrue: [ ^self ].
	prj := self projectClassProject.
	(currentVersion := prj currentVersion) = self versionOrNil
		ifTrue: [ ^self ].
	currentVersion == nil ifTrue: [ ^self ].
	spec := self copy.
	spec versionString: currentVersion versionString.
	updatedSpecs at: spec name put: spec! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/13/2011 12:54'!
version
	"Empty version string means use latestVersion or #bleedingEdge"

	self projectClass == nil
		ifTrue: [ ^ nil ].
	^ self versionString == nil
		ifTrue: [ 
			| vrsn |
			"Eventually it will become an error to not specify a project reference version as default: #stable is the preferred default"
			"self deprecated: 'Must specify a project reference version.'."
			self flag: 'deprecate after version 1.0'.
			(vrsn := self projectClassProject latestVersion) == nil
				ifTrue: [ self projectClassProject version: #bleedingEdge ]
				ifFalse: [ vrsn ] ]
		ifFalse: [ self projectClassProject version: self versionString ]! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 11/5/2010 15:55'!
versionOrNil

	^[ self version ] on: MetacelloVersionDoesNotExistError do: [:ex | ^nil ].
! !

AnObsoleteMetacelloVersionValidator subclass: #MetacelloMCVersionValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Validation'!

!MetacelloMCVersionValidator commentStamp: '<historical>' prior: 0!
Performs configuration validation.

For programmatically decoding reason codes use:

  MetacellMCVersionValidator fullDescriptionForReasonCode: <reasonCode>

Warning reason codes:

	#notDevelopmentVersion			- the symbolic version #development refers to a non-development literal version.
	#loadWarning 						- Warning signalled during load [load validation].
	#onlyBaselineVersion 				- one or more baseline versions have been defined, but no non-baseline versions are defined.
	#stableDevelopmentVersion		- a version whose blessing is #development has been declared as a #stable version

Critical Warning reason codes:

	#duplicateVersionDefinitions 		- there are multiple pragma methods specifying the same version
	#loadDeprecation					- deprecation warning signalled while loading configuration [load validation]
	#noLoadableVersions 				- no non #baseline versions defined in configuration
	#noTests 							- no test cases defined in loaded configuration [load validation]
	#noVersionSpecified 				- no version defined for the project reference or package. The version specified in the baseline or the latest version of the project or package in the repository will be used.
	#packageNameMismatch 			- the name in the packageSpec does not match the name of the mcz file
	#projectClassNameFileMismatch 	- the class name of the configuration does not match the mcz file containing the configuration
	#testDeprecation 					- deprecation warning signalled while running configuration tests [load validation]

Error reason codes:

	#cannotResolveVersion 			- the version (project reference or symbolic version) was not found in the specified configuration
	#duplicateNames 					- multiple independent definitions for an entity with same name (project, package, or group)
	#incompleteProjectSpec 			- missing required fields in project reference (className and/or repository)
	#incorrectVersionString 			- the version declared in pragma doesn't match version in versionSpec
	#invalidDoItSelector 				- doit select must be a Symbol
	#invalidVersionString 				- versionString must be a String
	#loadError 							- error occured while loading configuration [load validation]
	#missingVersionImport 			- version specified in import pragma not defined in configuration
	#noVersionsDefined 				- no usable baseline or version defined in configuration ... configuration cannot be loaded
	#projectCreationError 				- error occured while resolving project reference
	#shadowedNames 					- name duplication between packages and projects
	#testFailures						- test failures while running tests [load validation]
	#versionCompositionError 			- error while creating versionSpec from pragmas


!

!MetacelloMCVersionValidator class methodsFor: 'private' stamp: 'DaleHenrichs 1/24/2011 12:41'!
populateReasonCodeDescriptions

	| dict |
	dict := super populateReasonCodeDescriptions.
	"Warnings"
	dict at: #notDevelopmentVersion put: 'the symbolic version #development refers to a non-development literal version.'.
	dict at: #loadWarning put: 'Warning signalled during load [load validation].'.
	dict at: #stableDevelopmentVersion put: 'a version whose blessing is #development has been declared as a #stable version.'.
	"Critical Warnings"
	dict at: #loadDeprecation put: 'deprecation warning signalled while loading configuration [load validation].'.
	dict at: #noLoadableVersions put: 'no non #baseline versions defined in configuration.'.
	dict at: #noTests 		 put: 'no test cases defined in loaded configuration [load validation].'.
	dict at: #noVersionSpecified put: 'no version defined for the project reference or package. The version specified in the baseline or the latest version of the project or package in the repository will be used.'.
	dict at: #testDeprecation  put: 'deprecation warning signalled while running configuration tests [load validation].'.
	"Errors"
	dict at: #loadError put: 'error occured while loading configuration [load validation].'.
	dict at: #testFailures put: 'test failures while running tests [load validation].'.
	^dict! !

!MetacelloMCVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 11/19/2010 14:17'!
validateConfigurationLoad: configurationClass
	^ ((self new)
		configurationClass: configurationClass;
		yourself) validateProjectLoad! !

!MetacelloMCVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/7/2010 02:48'!
validateConfigurationLoad: configurationClass version: versionString
	^self validateConfigurationLoad: configurationClass version: versionString loads: #()
! !

!MetacelloMCVersionValidator class methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/7/2010 02:45'!
validateConfigurationLoad: configurationClass version: versionString loads: loadList
	^ ((self new)
		configurationClass: configurationClass;
		yourself) validateProjectVersionLoad: versionString loads: loadList! !

!MetacelloMCVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/30/2010 11:46'!
criticalWarningReasonCodes
	^ super criticalWarningReasonCodes
		, #(#noLoadableVersions #noTests #testDeprecation #loadDeprecation #noVersionSpecified)! !

!MetacelloMCVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/20/2010 07:25'!
errorReasonCodes
	^ super errorReasonCodes, #(#loadError #testFailures )! !

!MetacelloMCVersionValidator methodsFor: 'validation' stamp: 'DaleHenrichs 12/4/2010 08:45'!
validateBaselineVersionSpec: versionSpec
	| projectNames packageNames groupNames versionMessage |
	self
		validateDoIts: versionSpec
		versionString: versionSpec versionString
		errorMessage: ' version ' , versionSpec versionString printString.
	projectNames := Set new.
	packageNames := Set new.
	groupNames := Set new.
	versionMessage := ' in version ' , versionSpec versionString printString.
	versionSpec
		projectDo: [ :projectSpec | 
			(projectSpec resolveProjectSpec className == nil or: [ projectSpec resolveProjectSpec repository == nil ])
				ifTrue: [ 
					self
						recordValidationError:
							'Missing required fields (className: and/or repository:) for project reference ' , projectSpec name printString
								, ' in version ' , versionSpec versionString printString
						versionString: versionSpec versionString
						callSite: #validateBaselineVersionSpec:
						reasonCode: #incompleteProjectSpec ]
				ifFalse: [ 
					(self recurse and: [ projectSpec versionString ~~ nil ])
						ifTrue: [ 
							| project |
							projectSpec resolveProjectSpec ensureProjectLoaded.
							project := self
								validateProjectCreationFrom: projectSpec resolveProjectSpec projectClass
								onError: [ :ex | 
									self
										recordValidationError: 'Error creating project reference: ' , ex description
										versionString: versionSpec versionString
										callSite: #validateBaselineVersionSpec:
										reasonCode: #projectCreationError.
									nil ].
							project ~~ nil
								ifTrue: [ 
									self validationReport
										addAll:
											(self class
												validateProject: project
												version: projectSpec versionString
												debug: self debug
												recurse: self recurse
												visited: self visited) ] ] ].
			self
				validateDoIts: projectSpec
				versionString: versionSpec versionString
				errorMessage: projectSpec name printString , versionMessage.
			(projectNames includes: projectSpec name)
				ifTrue: [ 
					self
						recordValidationError: 'Duplicate projects named' , projectSpec name printString , versionMessage
						versionString: versionSpec versionString
						callSite: #validateBaselineVersionSpec:
						reasonCode: #duplicateNames ]
				ifFalse: [ projectNames add: projectSpec name ] ]
		packageDo: [ :packageSpec | 
			self
				validateDoIts: packageSpec
				versionString: versionSpec versionString
				errorMessage: packageSpec name printString , versionMessage.
			(packageNames includes: packageSpec name)
				ifTrue: [ 
					self
						recordValidationError: 'Duplicate packages named' , packageSpec name printString , versionMessage
						versionString: versionSpec versionString
						callSite: #validateBaselineVersionSpec:
						reasonCode: #duplicateNames ]
				ifFalse: [ projectNames add: packageSpec name ] ]
		groupDo: [ :groupSpec | 
			(groupNames includes: groupSpec name)
				ifTrue: [ 
					self
						recordValidationError: 'Duplicate groups named' , groupSpec name printString , versionMessage
						versionString: versionSpec versionString
						callSite: #validateBaselineVersionSpec:
						reasonCode: #duplicateNames ]
				ifFalse: [ projectNames add: groupSpec name ] ].
	(packageNames intersection: projectNames) notEmpty
		ifTrue: [ 
			self
				recordValidationError: 'Names duplicated between packages and projects' , versionMessage
				versionString: versionSpec versionString
				callSite: #validateBaselineVersionSpec:
				reasonCode: #shadowedNames ].
	(groupNames intersection: projectNames) notEmpty
		ifTrue: [ 
			self
				recordValidationError: 'Names duplicated between groups and projects' , versionMessage
				versionString: versionSpec versionString
				callSite: #validateBaselineVersionSpec:
				reasonCode: #shadowedNames ].
	(projectNames intersection: packageNames) notEmpty
		ifTrue: [ 
			self
				recordValidationError: 'Names duplicated between projects and packages' , versionMessage
				versionString: versionSpec versionString
				callSite: #validateBaselineVersionSpec:
				reasonCode: #shadowedNames ].
	(groupNames intersection: packageNames) notEmpty
		ifTrue: [ 
			self
				recordValidationError: 'Names duplicated between groups and packages' , versionMessage
				versionString: versionSpec versionString
				callSite: #validateBaselineVersionSpec:
				reasonCode: #shadowedNames ].
	(projectNames intersection: groupNames) notEmpty
		ifTrue: [ 
			self
				recordValidationError: 'Names duplicated between projects and groups' , versionMessage
				versionString: versionSpec versionString
				callSite: #validateBaselineVersionSpec:
				reasonCode: #shadowedNames ].
	(packageNames intersection: groupNames) notEmpty
		ifTrue: [ 
			self
				recordValidationError: 'Names duplicated between packages and groups' , versionMessage
				versionString: versionSpec versionString
				callSite: #validateBaselineVersionSpec:
				reasonCode: #shadowedNames ]! !

!MetacelloMCVersionValidator methodsFor: 'loading' stamp: 'DaleHenrichs 12/7/2010 02:49'!
validateCleanLoadAndTestsForVersion: version loads: loadList
	| cleanLoad cleanTests |
	cleanTests := cleanLoad := false.
	[ 
	self validateVersionLoad: version loads: loadList.
	cleanLoad := true ]
		on: Error , Warning
		do: [ :ex | 
			(ex isKindOf: Error)
				ifTrue: [ 
					self
						recordValidationError:
							'Error while loading version ' , version versionString printString , ' in ' , self configurationClass name asString
								, ' ' , ex description
						versionString: version versionString
						callSite: #validateCleanLoadAndTestsForVersion:loads:
						reasonCode: #loadError ].
			(ex isKindOf: Warning)
				ifTrue: [ 
					(ex isKindOf: Deprecation)
						ifTrue: [ 
							self
								recordValidationCriticalWarning:
									'Deprecation while loading version ' , version versionString printString , ' in '
										, self configurationClass name asString , ' ' , ex description
								versionString: version versionString
								callSite: #validateCleanLoadAndTestsForVersion:loads:
								reasonCode: #loadDeprecation ]
						ifFalse: [ 
							self
								recordValidationWarning:
									'Warning while loading version ' , version versionString printString , ' in ' , self configurationClass name asString
										, ' ' , ex description
								versionString: version versionString
								callSite: #validateCleanLoadAndTestsForVersion:loads:
								reasonCode: #loadWarning.
							Smalltalk
								at: #UndeclaredVariableWarning
								ifPresent: [ :undeclaredWrning | 
									(ex isKindOf: undeclaredWrning)
										ifTrue: [ ex resume: true ] ].
							ex resume ] ] ].
	cleanLoad
		ifTrue: [ 
			cleanTests := [ self validateVersionTests: version ]
				on: Deprecation
				do: [ :ex | 
					| message |
					message := 'Deprecation warning while running tests for version ' , version versionString printString , ' in '
						, self configurationClass name asString , ' ' , ex description.	"Deprecation warning for release tests is the same as a test failure"
					self
						recordValidationCriticalWarning: message
						versionString: version versionString
						callSite: #validateCleanLoadAndTestsForVersion:loads:
						reasonCode: #testDeprecation.
					ex return: false ].
			cleanTests
				ifTrue: [ MetacelloCleanLoadAndTestsNotification signal: version ]
				ifFalse: [ MetacelloCleanLoadNotification signal: version ] ]! !

!MetacelloMCVersionValidator methodsFor: 'loading' stamp: 'DaleHenrichs 12/7/2010 02:55'!
validateProjectLoad
	| issues project versions currentVersion collectedIssues |
	(issues := self validateProject select: [ :issue | issue isError ]) notEmpty
		ifTrue: [ ^ issues ].
	project := self configurationClass project.
	collectedIssues := issues.
	versions := project versions
		select: [ :version | 
			validationReport := nil.
			version blessing ~~ #broken
				and: [ 
					version blessing ~~ #baseline
						and: [ (issues := (self validateProject: project version: version versionString) select: [ :issue | issue isCritical ]) isEmpty ] ] ].
	validationReport := collectedIssues.
	versions isEmpty
		ifTrue: [ 
			self
				recordValidationCriticalWarning: 'No non #baseline versions  available  in ' , self configurationClass name asString
				callSite: #validateProjectLoad
				reasonCode: #noLoadableVersions.
			^ self validationReport ].
	(currentVersion := project currentVersion) ~~ nil
		ifTrue: [ 
			| index |
			index := versions indexOf: currentVersion.
			versions := versions copyFrom: index to: versions size ].
	versions do: [ :version | self validateCleanLoadAndTestsForVersion: version loads: #('ALL') ].
	^ self validationReport! !

!MetacelloMCVersionValidator methodsFor: 'loading' stamp: 'DaleHenrichs 12/17/2010 14:39'!
validateProjectVersionLoad: versionString loads: loadList
	| issues project currentVersion version |
	(issues := (self validateProjectVersion: versionString) select: [ :issue | issue isError ]) notEmpty
		ifTrue: [ ^ issues ].
	project := self configurationClass project.
	version := project
		version: versionString
		ifAbsent: [ 
			self
				recordValidationError: 'Version ' , versionString printString , ' does not exist.'
				callSite: #validateProjectVersionLoad:loads:
				reasonCode: #cannotResolveVersion.
			^ self validationReport ].
	version blessing = #broken
		ifTrue: [ self error: 'The specified version is #broken' ].
	self validateCleanLoadAndTestsForVersion: version loads: loadList.
	^ self validationReport! !

!MetacelloMCVersionValidator methodsFor: 'loading' stamp: 'DaleHenrichs 12/7/2010 02:54'!
validateVersionLoad: version loads: loadList
	| list |
	list := loadList asOrderedCollection.
	list isEmpty
		ifTrue: [ list add: 'default' ].
	(version groups includes: 'Tests')
		ifTrue: [ list add: 'Tests' ].
	version load: list! !

!MetacelloMCVersionValidator methodsFor: 'private' stamp: 'dkh 07/21/2011 15:40'!
validateVersionSpec: versionSpec
	versionSpec blessing value == #broken
		ifTrue: [ ^ self ].
	versionSpec
		projectDo: [ :projectSpec | 
			| referencedProjectSpec |
			projectSpec versionString == nil
				ifTrue: [ 
					self
						recordValidationCriticalWarning:
							'No version specified for the project reference ' , projectSpec name printString , ' in version '
								, versionSpec versionString printString
						versionString: versionSpec versionString
						callSite: #validateVersionSpec:
						reasonCode: #noVersionSpecified ].
			referencedProjectSpec := projectSpec referencedSpec.
			referencedProjectSpec projectPackage == nil
				ifTrue: [ 
					self
						recordValidationError:
							'The specification for the project reference ' , projectSpec name printString , ' in version '
								, versionSpec versionString printString , ' is missing the required repository field'
						versionString: versionSpec versionString
						callSite: #validateVersionSpec:
						reasonCode: #incompleteProjectSpec ]
				ifFalse: [ 
					(referencedProjectSpec file beginsWith: referencedProjectSpec className)
						ifFalse: [ 
							self
								recordValidationCriticalWarning:
									'The class name of project ' , referencedProjectSpec className printString , ' does not match the file name '
										, referencedProjectSpec file printString , ' in version ' , versionSpec versionString printString
								versionString: versionSpec versionString
								callSite: #validateVersionSpec:
								reasonCode: #projectClassNameFileMismatch ].
					referencedProjectSpec ensureProjectLoaded.
					[ projectSpec version ]
						on: MetacelloVersionDoesNotExistError
						do: [ :ex | 
							| explanation |
							explanation := projectSpec versionString == nil
								ifTrue: [ 'the default version' ]
								ifFalse: [ 'version ' , projectSpec versionString printString ].
							self
								recordValidationError:
									'Cannot resolve ' , explanation , ' for the project reference ' , projectSpec name printString , ' in version '
										, versionSpec versionString printString
								versionString: versionSpec versionString
								callSite: #validateVersionSpec:
								reasonCode: #cannotResolveVersion ] ] ]
		packageDo: [ :packageSpec | 
			(packageSpec file beginsWith: packageSpec name)
				ifFalse: [ 
					self
						recordValidationCriticalWarning:
							'The name of package ' , packageSpec name printString , ' does not match the file name ' , packageSpec file printString
								, ' in version ' , versionSpec versionString printString
						versionString: versionSpec versionString
						callSite: #validateVersionSpec:
						reasonCode: #packageNameMismatch ].
			packageSpec file = packageSpec name
				ifTrue: [ 
					self
						recordValidationCriticalWarning:
							'No version specified for the package ' , packageSpec name printString , ' in version '
								, versionSpec versionString printString
						versionString: versionSpec versionString
						callSite: #validateVersionSpec:
						reasonCode: #noVersionSpecified ] ]
		groupDo: [ :ignored |  ].
	self validateBaselineVersionSpec: versionSpec! !

!MetacelloMCVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 11/30/2010 13:52'!
validateVersionSpecForSymbolicVersion: versionSpec symbolicVersion: symbolicVersionString
	| blessing |
	versionSpec blessing value == #broken
		ifTrue: [ ^ self ].
	blessing := versionSpec blessing value.
	(symbolicVersionString == #development and: [ blessing ~~ #development ])
		ifTrue: [ 
			self
				recordValidationWarning:
					'Symbolic version ' , symbolicVersionString printString , ' refers to a version' , versionSpec versionString printString
						, ' whose blessing ' , blessing printString , ' is not #development'
				versionString: versionSpec versionString
				callSite: #validateVersionSpecForSymbolicVersion:symbolicVersion:
				reasonCode: #notDevelopmentVersion ]! !

!MetacelloMCVersionValidator methodsFor: 'loading' stamp: 'DaleHenrichs 12/5/2010 10:08'!
validateVersionTests: version
	| testCases cleanTests |
	testCases := IdentitySet new.
	cleanTests := true.
	version currentlyLoadedClassesInVersion
		do: [ :class | 
			((class inheritsFrom: TestCase) and: [ class isAbstract not ])
				ifTrue: [ testCases add: class ] ].
	testCases
		do: [ :testCase | 
			| testResults |
			testResults := testCase suite run.
			testResults defects notEmpty
				ifTrue: [ 
					self
						recordValidationError:
							'Test failures in tests ' , testCase name asString , ' for ' , version versionString printString , ' in '
								, self configurationClass name asString , ' ' , testResults printString
						versionString: version versionString
						callSite: #validateVersionTests:
						reasonCode: #testFailures.
					cleanTests := false ] ].
	testCases isEmpty
		ifTrue: [ 
			self
				recordValidationCriticalWarning:
					'No test cases for ' , version versionString printString , ' in ' , self configurationClass name asString
				versionString: version versionString
				callSite: #validateVersionTests:
				reasonCode: #noTests.
			cleanTests := false ].
	^ cleanTests! !

!MetacelloMCVersionValidator methodsFor: 'private' stamp: 'DaleHenrichs 12/4/2010 10:32'!
warningReasonCodes
	^ super warningReasonCodes, #(#loadWarning #notDevelopmentVersion #stableDevelopmentVersion)! !

AnObsoleteMetacelloSpec subclass: #MetacelloRepositorySpec
	instanceVariableNames: 'description username password type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloRepositorySpec methodsFor: 'adding' stamp: 'dkh 6/7/2009 10:13'!
addToMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec addMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloRepositorySpec methodsFor: 'printing' stamp: 'dkh 10/22/2009 09:54'!
configMethodCascadeOn: aStream lastCascade: lastCascade

	aStream nextPutAll: 'repository: ', self description printString.
	(self username isEmpty not or: [ self password isEmpty not ])
		ifTrue: [ aStream nextPutAll: ' username: ', self username printString, ' password: ', self password printString ].
	lastCascade ifFalse: [ aStream nextPut: $;; cr ].
! !

!MetacelloRepositorySpec methodsFor: 'printing' stamp: 'dkh 10/22/2009 09:54'!
configMethodOn: aStream indent: indent

	aStream 
		tab: indent; 
		nextPutAll: 'spec '.
	self configMethodCascadeOn: aStream lastCascade: true! !

!MetacelloRepositorySpec methodsFor: 'mc support' stamp: 'dkh 10/22/2009 08:52'!
createRepository

	^self project createRepository: self ! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 06/03/2009 12:16'!
description

	^description! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 06/03/2009 12:15'!
description: aString

	description := aString! !

!MetacelloRepositorySpec methodsFor: 'private' stamp: 'TestRunner 12/7/2009 14:30'!
extractTypeFromDescription

	^MetacelloPlatform current extractTypeFromDescription: self description! !

!MetacelloRepositorySpec methodsFor: 'private' stamp: 'dkh 6/7/2009 10:21'!
mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec mergeMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloRepositorySpec methodsFor: 'merging' stamp: 'dkh 10/22/2009 09:11'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #description put: description.
	map at: #type put: type.
	map at: #username put: username.
	map at: #password put: password.
	^map! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 6/7/2009 10:33'!
name

	^self description! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 10/22/2009 08:49'!
password

	password == nil ifTrue: [ password := '' ].
	^password! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 08:49'!
password: aString

	password := aString! !

!MetacelloRepositorySpec methodsFor: 'private' stamp: 'dkh 6/7/2009 10:24'!
removeFromMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec removeMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 06/03/2009 12:16'!
type

	type == nil ifTrue: [ type := self extractTypeFromDescription ].
	^type! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 06/03/2009 12:15'!
type: aString

	type := aString! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 10/22/2009 08:49'!
username

	username == nil ifTrue: [ username := '' ].
	^username! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 08:49'!
username: aString

	username := aString! !

AnObsoleteMetacelloVersionSpec subclass: #MetacelloMCVersionSpec
	instanceVariableNames: 'packages repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 7/8/2011 20:11'!
computeVersionStatus: matchBlock
	self computeVersionStatus: (self expandToLoadableSpecNames: #('ALL')) matchBlock: matchBlock! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 7/11/2011 15:47'!
computeVersionStatus: resolvedPackageAndProjectNames matchBlock: matchBlock
	| status |
	status := resolvedPackageAndProjectNames isNil
		ifTrue: [ self isPartiallyCurrent ]
		ifFalse: [ self isPartiallyCurrentAgainst: resolvedPackageAndProjectNames ].
	status isAllLoadedToSpec: matchBlock.
	status isLoadedToSpec: matchBlock.
	status isLoadedMatchConstraints: matchBlock.
	status isSomethingLoaded: matchBlock! !

!MetacelloMCVersionSpec methodsFor: 'printing' stamp: 'DaleHenrichs 12/23/2010 13:48'!
configMethodOn: aStream last: last indent: indent
	| spec hasRepositories hasPackageSpecs |
	hasRepositories := (spec := self repositoriesSpec) ~~ nil and: [ spec list isEmpty not ].
	hasPackageSpecs := false.
	self packagesSpec list
		do: [ :member | 
			member spec
				projectDo: [ :proj | 
					member spec name ~~ nil
						ifTrue: [ hasPackageSpecs := true ] ]
				packageDo: [ :package | 
					member spec name ~~ nil
						ifTrue: [ hasPackageSpecs := true ] ]
				groupDo: [ :group | 
					member spec name ~~ nil
						ifTrue: [ hasPackageSpecs := true ] ] ].
	super configMethodOn: aStream last: (hasRepositories | hasPackageSpecs) not indent: indent.
	hasRepositories
		ifTrue: [ 
			spec map values size = 1
				ifTrue: [ 
					aStream
						tab: indent;
						nextPutAll: 'spec repository: ';
						nextPutAll: spec map values first description printString , '.'.
					hasPackageSpecs ifTrue: [ aStream cr ]]
				ifFalse: [ 
					self
						configMethodOn: aStream
						for: spec
						selector: 'repositories:'
						last: hasPackageSpecs not 
						indent: indent ] ].
	self configPackagesSpecMethodOn: aStream indent: indent.
	last
		ifFalse: [ aStream cr ]! !

!MetacelloMCVersionSpec methodsFor: 'printing' stamp: 'dkh 10/6/2009 14:26'!
configPackagesSpecMethodOn: aStream indent: indent

	| projectSpecs packageSpecs groupSpecs |
	projectSpecs := OrderedCollection new.
	packageSpecs := OrderedCollection new.
	groupSpecs := OrderedCollection new.
	self packagesSpec list do: [:member |
		member spec 
			projectDo: [:proj | member spec name ~~ nil ifTrue: [ projectSpecs add: member ]]
			packageDo: [:package | member spec name ~~ nil ifTrue: [ packageSpecs add: member ]]
			groupDo: [:group | member spec name ~~ nil ifTrue: [ groupSpecs add: member ]]].
	projectSpecs isEmpty not
		ifTrue: [
			aStream tab: indent; nextPutAll: 'spec '.
			projectSpecs size > 1 ifTrue: [ aStream cr; tab: indent + 1 ].
			1 to: projectSpecs size  do: [:index | 
				(projectSpecs at: index) configMethodCascadeOn: aStream last: index == projectSpecs size indent: indent + 1.
				index ~= projectSpecs size ifTrue: [ aStream tab: indent + 1 ]]].
	packageSpecs isEmpty not
		ifTrue: [
			projectSpecs isEmpty not ifTrue: [ aStream cr ].
			aStream tab: indent; nextPutAll: 'spec '.
			packageSpecs size > 1 ifTrue: [ aStream cr; tab: indent + 1 ].
			1 to: packageSpecs size  do: [:index | 
				(packageSpecs at: index) configMethodCascadeOn: aStream last: index == packageSpecs size indent: indent + 1.
				index ~= packageSpecs size ifTrue: [ aStream tab: indent + 1 ]]].
	groupSpecs isEmpty not
		ifTrue: [
			projectSpecs isEmpty not | packageSpecs isEmpty not ifTrue: [ aStream cr ].
			aStream tab: indent; nextPutAll: 'spec '.
			groupSpecs size > 1 ifTrue: [ aStream cr; tab: indent + 1 ].
			1 to: groupSpecs size  do: [:index | 
				(groupSpecs at: index) configMethodCascadeOn: aStream last: index == groupSpecs size indent: indent + 1.
				index ~= groupSpecs size ifTrue: [ aStream tab: indent + 1 ]]].
! !

!MetacelloMCVersionSpec methodsFor: 'printing' stamp: 'dkh 10/9/2009 20:40'!
configSpawnMethodOn: aStream indent: indent

	super configSpawnMethodOn: aStream indent: indent.
	self configPackagesSpecMethodOn: aStream indent: indent.! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'DaleHenrichs 11/20/2010 08:14'!
currentlyLoadedClassesInVersion
	| classes |
	classes := Set new.
	self
		projectDo: [ :ignored |  ]
		packageDo: [ :packageSpec | 
			| wc |
			wc := [ packageSpec workingCopy ] on: Error do: [ :ex | ex return: nil ].
			wc ~~ nil
				ifTrue: [ classes addAll: wc packageInfo classes ] ]
		groupDo: [ :ignored |  ].
	^ classes! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'dkh 5/12/2011 16:31'!
currentlyLoadedExtensionClassesInVersion
	| classes |
	classes := Dictionary new.
	self
		projectDo: [ :ignored |  ]
		packageDo: [ :packageSpec | 
			| wc |
			wc := [ packageSpec workingCopy ] on: Error do: [ :ex | ex return: nil ].
			wc ~~ nil
				ifTrue: [ wc packageInfo extensionClasses do: [:cl |
						classes at: cl put: (wc packageInfo extensionCategoriesForClass: cl)]] ]
		groupDo: [ :ignored |  ].
	^ classes! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'dkh 10/9/2009 13:03'!
defaultPackageNames
	"if there is a package named 'default' (a group) then it defines the default package names,
	 otherwise answer a list of all of the package names in this version"

	self packages packageNamed: 'default' ifAbsent: [ ^self packageNames ].
	^#('default')! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/14/2011 11:37'!
difference: otherVersionSpec
	"Return a a dictionary of additions, removals and modifications"

	| report myProjectSpecs myPackageSpecs otherProjectSpecs otherPackageSpecs |
	report := MetacelloMCVersionDiffReport new.
	myProjectSpecs := Dictionary new.
	myPackageSpecs := Dictionary new.
	self
		projectDo: [ :projectSpec | myProjectSpecs at: projectSpec name put: projectSpec ]
		packageDo: [ :packageSpec | myPackageSpecs at: packageSpec name put: packageSpec ]
		groupDo: [ :ignored |  ].
	otherProjectSpecs := Dictionary new.
	otherPackageSpecs := Dictionary new.
	otherVersionSpec
		projectDo: [ :projectSpec | otherProjectSpecs at: projectSpec name put: projectSpec ]
		packageDo: [ :packageSpec | otherPackageSpecs at: packageSpec name put: packageSpec ]
		groupDo: [ :ignored |  ].
	myProjectSpecs
		valuesDo: [ :myProjectSpec | 
			| otherProjectSpec |
			otherProjectSpec := otherProjectSpecs at: myProjectSpec name ifAbsent: [  ].
			otherProjectSpec == nil
				ifTrue: [ 
					report removals
						at: myProjectSpec name
						put:
							{(myProjectSpec versionString).
							''} ]
				ifFalse: [ 
					myProjectSpec versionString = otherProjectSpec versionString
						ifFalse: [ 
							report modifications
								at: myProjectSpec name
								put:
									{(myProjectSpec versionString).
									(otherProjectSpec versionString)} ] ] ].
	otherProjectSpecs
		valuesDo: [ :otherProjectSpec | 
			(myProjectSpecs at: otherProjectSpec name ifAbsent: [  ]) == nil
				ifTrue: [ 
					report additions
						at: otherProjectSpec name
						put:
							{''.
							(otherProjectSpec versionString)} ] ].
	myPackageSpecs
		valuesDo: [ :myPackageSpec | 
			| otherPackageSpec |
			otherPackageSpec := otherPackageSpecs at: myPackageSpec name ifAbsent: [  ].
			otherPackageSpec == nil
				ifTrue: [ 
					report removals
						at: myPackageSpec name
						put:
							{(myPackageSpec file).
							''} ]
				ifFalse: [ 
					myPackageSpec file = otherPackageSpec file
						ifFalse: [ 
							report modifications
								at: myPackageSpec name
								put:
									{(myPackageSpec file).
									(otherPackageSpec file)} ] ] ].
	otherPackageSpecs
		valuesDo: [ :otherPackageSpec | 
			(myPackageSpecs at: otherPackageSpec name ifAbsent: [  ]) == nil
				ifTrue: [ 
					report additions
						at: otherPackageSpec name
						put:
							{''.
							(otherPackageSpec file)} ] ].
	^report! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'DaleHenrichs 9/24/2010 14:50'!
expandToLoadableSpecNames: nameList

	| cacheKey names |
	cacheKey := Array with: self label with: nameList.
	^MetacelloPlatform current
		stackCacheFor: #loadableSpecNames
		at: cacheKey
		doing: [ :cache | 
			names := (self resolveToLoadableSpecs: nameList) collect: [:spec | spec name ].
			cache at: cacheKey put: names ].
! !

!MetacelloMCVersionSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/12/2010 06:30'!
forceUpdatedPackageSpecs

	| updatedSpecs mcLoader |
	updatedSpecs := Dictionary new.
	mcLoader := self loader.
	self packages map valuesDo: [:pkg | pkg forceUpdatePackageSpec: updatedSpecs using: mcLoader].
	^updatedSpecs! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 07/12/2011 14:08'!
isAllLoadedToSpec
	"all projects and packages are loaded and match specification"

	self isPartiallyCurrent isAllLoadedToSpec: [ :ignored | ^ true ].
	^ false! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 7/11/2011 16:02'!
isAllLoadedToSpecAgainst: resolvedPackageAndProjectNames
	"all projects and packages are loaded and match specification"

	(self isPartiallyCurrentAgainst: resolvedPackageAndProjectNames) isAllLoadedToSpec: [ :ignored | ^ true ].
	^ false! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 07/12/2011 14:08'!
isLoadedMatchConstraints
	"all loaded projects and packages match constraints (at least one package loaded)"
	
	self isPartiallyCurrent isLoadedMatchConstraints: [ :ignored | ^ true ].
	^ false! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 7/11/2011 16:06'!
isLoadedMatchConstraintsAgainst: resolvedPackageAndProjectNames
	"all loaded projects and packages match constraints (at least one package loaded)"

	(self isPartiallyCurrentAgainst: resolvedPackageAndProjectNames) isLoadedMatchConstraints: [ :ignored | ^ true ].
	^ false! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 07/12/2011 14:08'!
isLoadedToSpec
	"all loaded projects and packages match specifications (at least one package loaded)"
	
	self isPartiallyCurrent isLoadedToSpec: [ :ignored | ^ true ].
	^ false! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 07/12/2011 14:07'!
isLoadedToSpecAgainst: resolvedPackageAndProjectNames
	"all loaded projects and packages match specifications (at least one package loaded)"

	(self isPartiallyCurrentAgainst: resolvedPackageAndProjectNames) isLoadedToSpec: [ :ignored | ^ true ].
	^ false! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 7/8/2011 14:45'!
isPartiallyCurrent

	^self isPartiallyCurrentAgainst: (self expandToLoadableSpecNames: #('ALL'))! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 7/11/2011 15:43'!
isPartiallyCurrentAgainst: resolvedPackageAndProjectNames
	| mcLoader status |
	status := MetacelloMCPartiallyLoadedStatus new.
	mcLoader := self loader.
	self
		specsNamed: resolvedPackageAndProjectNames
		projectDo: [ :prj | 
			| vrsn currentVersion |
			status hasNoProject: false.
			vrsn := prj versionOrNil.
			vrsn ~~ nil
				ifTrue: [ 
					(currentVersion := prj relativeCurrentVersion) ~~ nil
						ifTrue: [ status vrsnStatus add: currentVersion versionStatus ] ].
			currentVersion ~~ nil
				ifTrue: [ 
					status aProjectIsLoaded: true.
					(currentVersion perform: #= with: vrsn)
						ifTrue: [ status aLoadedProjectIsExact: true ]
						ifFalse: [ 
							(currentVersion perform: prj projectReference operator with: vrsn)
								ifTrue: [ status aLoadedProjectIsCurrent: true ]
								ifFalse: [ status aLoadedProjectIsNotCurrent: true ] ] ]
				ifFalse: [ status aProjectNotLoaded: true ] ]
		packageDo: [ :pkg | 
			status hasNoPackage: false.
			pkg
				currentPackageLoaded: [ :versionInfos :file | 
					| wcName wcRef fileRef exact current |
					status aPackageIsLoaded: true.
					versionInfos isEmpty
						ifTrue: [ status aLoadedPackageIsNotCurrent: true ]
						ifFalse: [ 
							exact := current := false.
							versionInfos
								do: [ :vi | 
									wcName := vi name.
									fileRef := GoferResolvedReference name: file.
									wcRef := GoferResolvedReference name: wcName.
									(wcRef compare: fileRef using: #=)
										ifTrue: [ exact := true ] ].
							exact
								ifTrue: [ status aLoadedPackageIsExact: true ]
								ifFalse: [ 
									versionInfos
										do: [ :vi | 
											wcName := vi name.
											fileRef := GoferResolvedReference name: file.
											wcRef := GoferResolvedReference name: wcName.
											(wcRef compare: fileRef using: #>=)
												ifTrue: [ current := true ] ].
									current
										ifTrue: [ status aLoadedPackageIsCurrent: true ]
										ifFalse: [ status aLoadedPackageIsNotCurrent: true ] ] ] ]
				notLoaded: [ status aPackageNotLoaded: true ]
				using: mcLoader ]
		groupDo: [ :ignoredGroup | 
			"if we encounter a group, trouble"
			status abort: true.
			^ status ].
	^ status! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 1/21/2010 13:26'!
isPossibleBaseline

	self 
		projectDo: [:prj | prj isPossibleBaseline ifFalse: [ ^false ]] 
		packageDo: [:pkg | pkg isPackageLoaded ifFalse: [ ^false ]] 
		groupDo: [:ignored | ].
	^true! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 07/12/2011 14:08'!
isSomethingLoaded
	"at least one package loaded"
	
	self isPartiallyCurrent isSomethingLoaded: [ :ignored | ^ true ].
	^ false! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'dkh 07/12/2011 14:07'!
isSomethingLoadedAgainst: resolvedPackageAndProjectNames
	"at least one package loaded"

	(self isPartiallyCurrentAgainst: resolvedPackageAndProjectNames) isSomethingLoaded: [ :ignored | ^ true ].
	^ false
! !

!MetacelloMCVersionSpec methodsFor: 'merging' stamp: 'dkh 10/9/2009 07:34'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #packages put: self packages.
	map at: #repositories put: self repositories.
	^map! !

!MetacelloMCVersionSpec methodsFor: 'merging' stamp: 'dkh 9/23/2009 11:54'!
mergeSpec: anotherSpec

	| newSpec map anotherPackages anotherRepositories |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherPackages := map at: #packages) isEmpty not 
		ifTrue: [ 
			newSpec 
				packages: (self packages isEmpty
					ifTrue: [ anotherPackages ]
					ifFalse: [ self packages mergeSpec: anotherPackages ]) ].
	(anotherRepositories := map at: #repositories) isEmpty not
		ifTrue: [ 
			newSpec 
				repositories: (self repositories isEmpty
					ifTrue: [ anotherRepositories ]
					ifFalse: [ self repositories mergeSpec: anotherRepositories ]) ].
	^newSpec! !

!MetacelloMCVersionSpec methodsFor: 'merging' stamp: 'dkh 9/23/2009 11:54'!
nonOverridable

	^super nonOverridable, #( packages repositories)! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'dkh 10/21/2009 13:55'!
packageNamed: aString

	^self packageNamed: aString ifAbsent: [ nil ]! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 15:52'!
packageNamed: aString forMap: map ifAbsent: aBlock

	| package |
	package := map
				at: aString
				ifAbsent: [].
	package == nil
		ifTrue: [
			(aString = 'default' or: [ aString = 'ALL'])
				ifTrue: [ 
					package := self project groupSpec name: aString;
				 		includes: self packageNames;					 
						yourself ]
				ifFalse: [ ^aBlock value ]].
	^package! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 15:52'!
packageNamed: aString ifAbsent: aBlock

	^self packageNamed: aString forMap: self packages map ifAbsent: aBlock! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'dkh 7/8/2011 09:51'!
packageNames

	packages == nil ifTrue: [ ^#() ].
	^self packages map keys asSet ! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'dkh 6/17/2009 16:06'!
packageSpecsInLoadOrder

	^self packages packageSpecsInLoadOrder! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/17/2009 16:05'!
packages

	packages == nil ifTrue: [ packages := self project packagesSpec ].
	^ packages! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/7/2009 08:19'!
packages: anObject
	packages := anObject! !

!MetacelloMCVersionSpec methodsFor: 'development support' stamp: 'dkh 12/22/2009 09:56'!
packagesNeedSavingVisited: visitedProjects into: aCollection

	self packages map valuesDo: [:pkg | pkg packagesNeedSavingVisited: visitedProjects using: self repositories map values into: aCollection ].
! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/23/2009 17:16'!
packagesSpec

	^self packages! !

!MetacelloMCVersionSpec methodsFor: 'copying' stamp: 'dkh 10/9/2009 07:34'!
postCopy

	super postCopy.
	packages := packages copy.
	repositories := repositories copy.
	! !

!MetacelloMCVersionSpec methodsFor: 'enumerating' stamp: 'dkh 10/20/2009 17:16'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	self packageSpecsInLoadOrder do: [:pkgSpec |
		pkgSpec projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock ]! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/17/2009 16:05'!
repositories
	repositories == nil ifTrue: [ repositories := self project repositoriesSpec ].
	^ repositories! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/7/2009 08:20'!
repositories: anObject
	repositories := anObject! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/23/2009 17:18'!
repositoriesSpec

	^self repositories! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/7/2009 16:27'!
repository: aString
	self repositoriesSpec add: aString! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 14:24'!
repository: aString username: username password: password
	self repositoriesSpec repository: aString username: username password: password! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'dkh 6/18/2009 10:13'!
repositorySpecs

	^self repositories map values! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'DaleHenrichs 2/5/2010 22:24'!
resolveToLoadableSpec: aString forMap: map packages: packageMap 
	| package |
	package := self packageNamed: aString forMap: map ifAbsent: [ ^self error: 'Name not found: ' , aString ].
	packageMap at: package name put: package.
	^ {package}! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'DaleHenrichs 2/3/2010 15:42'!
resolveToLoadableSpecs: nameList
	"Resolves names in namelist to the  list of packages and projects in the version that would be loaded. Projects are 
	not traversed during the transitive closure. The scope is that of the version itself.
	   If the spec is a package, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer the project.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"

	| map |
	map := Dictionary new.
	self resolveToLoadableSpecs: nameList map: map.
	^map values! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'dkh 2/26/2011 10:11'!
resolveToLoadableSpecs: required map: packageMap 

	| reqd allReqd map newReqd spec |
	reqd := required copy.
	allReqd := Set new.
	map := self packages map.
	[ reqd isEmpty ] whileFalse: [
		newReqd := Set new.
		reqd do: [:req | 
			(self resolveToLoadableSpec: req forMap: map packages: packageMap) 
				do: [:loadableSpec | 
					newReqd addAll: loadableSpec requires.
					newReqd addAll: loadableSpec includes ]].
		allReqd addAll: reqd.
		newReqd removeAllFoundIn: allReqd.
		reqd := newReqd ].
	packageMap keys do: [:pkgName |
		(spec := (packageMap at: pkgName) resolveToLoadableSpec) == nil
			ifTrue: [ packageMap removeKey: pkgName ]
			ifFalse: [ packageMap at: pkgName put: (packageMap at: pkgName) resolveToLoadableSpec ]]! !

!MetacelloMCVersionSpec methodsFor: 'enumerating' stamp: 'DaleHenrichs 11/12/2010 15:31'!
specListProjectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	self packages specListDo: [:pkgSpec |
		pkgSpec projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock ]! !

!MetacelloMCVersionSpec methodsFor: 'enumerating' stamp: 'DaleHenrichs 01/20/2010 15:50'!
specsNamed: packageAndProjectNames projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	| map |
	map := self packages map.
	packageAndProjectNames do: [:name | | pkgSpec |
		(pkgSpec := map at: name ifAbsent: [ ]) ~~ nil
			ifTrue: [ pkgSpec projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock ]]! !

!MetacelloMCVersionSpec methodsFor: 'development support' stamp: 'DaleHenrichs 11/17/2010 12:02'!
updateForSpawnMethod: sourceSpec
	"This means that this spec was used in a baseline and will be used in a version .... drop all information that isn't useful"
	
	repositories := preLoadDoIt := postLoadDoIt := nil.
! !

!MetacelloMCVersionSpec methodsFor: 'development support' stamp: 'dkh 10/5/2009 16:15'!
updatedPackageSpecs

	| updatedSpecs mcLoader |
	updatedSpecs := Dictionary new.
	mcLoader := self loader.
	self packages map valuesDo: [:pkg | pkg updatePackageSpec: updatedSpecs using: mcLoader].
	^updatedSpecs! !

!MetacelloMCVersionSpec methodsFor: 'private' stamp: 'dkh 10/7/2009 14:45'!
versionClass

	^MetacelloMCVersion! !

AnObsoleteMetacelloVersion subclass: #MetacelloMCVersion
	instanceVariableNames: 'loaderPolicy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Model'!

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 19:15'!
allPackagesForSpecNamed: aStringOrArray
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer a list of the packages associated with the project,
			following the transitive closure on packages reachable starting with the #loads: field.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"In essence, this query answers the list of all packages that would be loaded if the package 
		named <aString> were loaded."
	"If there is no spec named <aString>, answers an empty list"

	^self allPackagesForSpecNamed: aStringOrArray ifAbsent: [ ^#() ]! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 19:16'!
allPackagesForSpecNamed: aStringOrArray ifAbsent: aBlock
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer a list of the packages associated with the project,
			following the transitive closure on packages reachable starting with the #loads: field.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"In essence, this query answers the list of all packages that would be loaded if the package 
		named <aString> were loaded."
	"If there is no spec named <aString>, aBlock is evaluated"

	^aStringOrArray 
		resolvePackageSpecsNamedForMetacelloMCVersion: self 
		visited: MetacelloVisitedPackages new 
		ifAbsent: aBlock 
! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'dkh 10/21/2009 19:17'!
allPackagesForSpecs: pkgSpecs visited: visited

 
	| coll |
	coll := Dictionary new.
	pkgSpecs
		do: [:pkgSpec | (pkgSpec resolveToAllPackagesIn: self spec visited: visited)
				do: [:pkg | coll at: pkg name put: pkg ]].
	^ coll values asOrderedCollection
! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/29/2010 15:32'!
cacheRepository: repository 
	"by default cacheRepository is an MCDictionaryRepository"
	
	self loaderPolicy cacheRepository: repository ! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 11/20/2010 08:14'!
currentlyLoadedClassesInVersion

	^self spec currentlyLoadedClassesInVersion! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 5/11/2011 14:36'!
currentlyLoadedExtensionClassesInVersion

	^self spec currentlyLoadedExtensionClassesInVersion! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 11/9/2010 16:41'!
defaultPackageNamesToLoad
	"Answer the list of packages and projects to be loaded --> packages already loaded"
	
	^ self defaultPackageNamesToLoad: self spec defaultPackageNames! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 10/25/2010 15:32'!
defaultPackageNamesToLoad: defaultList
	"Answer the list of packages and projects to be loaded: packages already loaded plust defaultList"
	
	^ self packageAndProjectNamesToLoad: defaultList loader: self loader! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 11/8/2010 12:58'!
difference: aMetacelloVersion
	"Return a a dictionary of additions, removals and modifications"
	
	^self spec difference: aMetacelloVersion spec! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 4/9/2010 14:48'!
doFetchRequiredFromArray: anArray

	| oldPolicy oldBypassProgress displayString |
	displayString := self versionNumber printString, ' of ', self spec projectLabel.
	Transcript cr; show: 'Fetching ', displayString, '...'.
	oldPolicy := loaderPolicy. 
	oldBypassProgress := MetacelloPlatform current bypassProgressBars.
	self loaderPolicy silently ifTrue: [ MetacelloPlatform current bypassProgressBars: true ].
	[ 	| ans |
		ans := self fetchRequiredFromArray: anArray.
		Transcript cr; show: '...finished ', self versionNumber printString.
		^ans ]
			ensure: [ 
				MetacelloPlatform current bypassProgressBars: oldBypassProgress.
				loaderPolicy := oldPolicy ]
	! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'dkh 6/6/2011 10:24'!
doLoadRequiredFromArray: anArray

	| displayString oldPolicy oldBypassProgress |
	displayString := self versionNumber printString, ' of ', self spec projectLabel.
	Transcript cr; show: 'Loading ', displayString, '...'.
	oldPolicy := loaderPolicy. 
	oldBypassProgress := MetacelloPlatform current bypassProgressBars.
	self loaderPolicy silently ifTrue: [ MetacelloPlatform current bypassProgressBars: true ].
	[	| fetchLoader |
		fetchLoader := self fetchRequiredFromArray: (self defaultPackageNamesToLoad: anArray).
		MetacelloPlatform current
			do:  [  fetchLoader doLoad ]
			displaying: 'Loading ', displayString.
		Transcript cr; show: '...finished ', self versionNumber printString.
		^fetchLoader ]
		ensure: [ 
			MetacelloPlatform current bypassProgressBars: oldBypassProgress.
			loaderPolicy := oldPolicy ]
! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 4/9/2010 14:48'!
doRecordRequiredFromArray: anArray

	| originalLoader oldPolicy displayString oldBypassProgress |
	displayString := self versionNumber printString, ' of ', self spec projectLabel.
	Transcript cr; show: 'Recording ', displayString, '...'.
	originalLoader := self versionSpec loader.
	oldPolicy := loaderPolicy. 
	oldBypassProgress := MetacelloPlatform current bypassProgressBars.
	self loaderPolicy silently ifTrue: [ MetacelloPlatform current bypassProgressBars: true ].
	[	MetacelloPlatform current
			do:  [ | ans |
				self versionSpec loader: originalLoader recordingSpecLoader.
				ans := (self executeLoadFromArray: anArray) copy.
				Transcript cr; show: '...finished ', self versionNumber printString.
				^ans ]
			displaying: 'Recording ', displayString ]
				ensure: [
					MetacelloPlatform current bypassProgressBars: oldBypassProgress.
					self versionSpec loader: originalLoader.
					loaderPolicy := oldPolicy ]! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 11/2/2010 16:09'!
executeLoadFromArray: anArray

	| loader mcLoader |
	loader := MetacelloMCVersionSpecLoader on: self spec.
	loader required: anArray.
	loaderPolicy notNil ifTrue: [ loader loaderPolicy: loaderPolicy ].
	^loader load! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 2/4/2010 10:32'!
expandToLoadableSpecNames: nameList
	"Just like #resolveToLoadableSpecs:, but returns list of spec names instead of specs"
	
	^self spec expandToLoadableSpecNames: nameList! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/7/2010 08:25'!
fetch

	^self doFetchRequiredFromArray: self spec defaultPackageNames! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/7/2010 08:25'!
fetch: required

	^required fetchRequiredForMetacelloMCVersion: self
! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'dkh 4/6/2011 22:23'!
fetchRequiredFromArray: anArray
	| originalLoader displayString newLoader |
	originalLoader := self versionSpec loader.
	newLoader := originalLoader fetchingSpecLoader.
	displayString := newLoader actionLabel , self versionNumber printString , ' of ' , self spec projectLabel.
	MetacelloPlatform current
		do: [ 
			[ 
			self versionSpec loader: newLoader.
			MetacelloPlatform current
				useStackCacheDuring: [ :dict | ^ self executeLoadFromArray: anArray ]
				defaultDictionary: Dictionary new ] ensure: [ self versionSpec loader: originalLoader ] ]
		displaying: displayString! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 14:37'!
groups
	"Answers the list of groups associated with this version"
	
	| groups |
	groups := OrderedCollection new.
	self spec projectDo: [:ignored | ] packageDo: [:ignored | ] groupDo: [:grp | groups add: grp ].
	^groups
! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/29/2010 15:31'!
ignoreImage: aBool 
	"by default ignoreImage is false"
	
	self loaderPolicy ignoreImage: aBool ! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/4/2010 15:37'!
load

	^self doLoadRequiredFromArray: self spec defaultPackageNames! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'dkh 6/15/2009 22:34'!
load: required

	^required loadRequiredForMetacelloMCVersion: self
! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 3/11/2010 14:06'!
loadRequiredFromArray: anArray

	| displayString |
	displayString := 'Loading ', self versionNumber printString, ' of ', self spec projectLabel.
	MetacelloPlatform current
		do: [ ^self executeLoadFromArray: anArray ]
		displaying: displayString! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'dkh 6/18/2009 10:12'!
loader: aLoader

	self versionSpec loader: aLoader! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 08:21'!
loaderPolicy

	loaderPolicy == nil ifTrue: [ loaderPolicy := MetacelloLoaderPolicy new ].
	^ loaderPolicy! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 08:20'!
loaderPolicy: anObject
	loaderPolicy := anObject! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 10/25/2010 15:32'!
packageAndProjectNamesToLoad: defaultList loader: aLoader
	"Answer the list of packages and projects to be loaded: packages already loaded plust defaultList"
	
	| loadedPackageNames projectMap loadedProjectNames list |
	loadedPackageNames := ((self packages select: [:pkg | pkg isPackageLoaded: aLoader ]) 
		collect: [:pkg | pkg name ]) asSet, 
			defaultList.
	projectMap := Dictionary new.
	self  projects do: [:prj | 
		prj className ~~ nil
			ifTrue: [ | coll loaded |
				coll := projectMap at: prj className ifAbsent: [
					coll := OrderedCollection new.
					projectMap at: prj className put: coll.
					coll].
				(loaded := prj loadedPackageNames: aLoader) isEmpty 
					ifFalse: [  coll add: prj -> (loaded -> prj loadPackageList) ]]].
	loadedProjectNames := Set new.
	projectMap keysAndValuesDo: [:prjClass :coll |
		coll size <= 1
			ifTrue: [ coll do: [:assoc | loadedProjectNames add: assoc key name ]]
			ifFalse: [ 
				"multiple project references against the same configuration ... only count project as loaded
				 if there is an exact match for loaded projects...
				 See http://code.google.com/p/metacello/issues/detail?id=86"
				coll do: [:assoc | | loaded packageList |
					loaded := assoc value key. "loaded packages from project"
					packageList := assoc value value. "loadlist for project"
					(packageList difference: loaded) isEmpty
						ifTrue: [ loadedProjectNames add: assoc key name ]]]].
	list := loadedPackageNames, loadedProjectNames.
	list isEmpty ifTrue: [ ^self spec defaultPackageNames].
	^list! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/24/2009 20:02'!
packageNamed: aString

	^self packageNamed: aString ifAbsent: [ ^nil ].
! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/24/2009 20:04'!
packageNamed: aString ifAbsent: aBlock

	| pkg |
	(pkg := self spec packageNamed: aString ifAbsent: []) == nil
		ifTrue: [ ^aBlock value ].
	^pkg referencedSpec! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 14:37'!
packages
	"Answers the list of packages associated with this version"

	| packages |
	packages := OrderedCollection new.
	self spec projectDo: [:ignored | ] packageDo: [:pkg | packages add: pkg ] groupDo: [:ignored | ].
	^packages
! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 15:06'!
packagesForSpecNamed: aString
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including only the package. #requires: and #includes:
			fields in the package are ignored.
	   If the spec is a project, answers an empty list.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"If there is no spec named <aString>, answers an empty list"

	^self packagesForSpecNamed: aString ifAbsent: [ ^#() ]! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 15:20'!
packagesForSpecNamed: aString ifAbsent: aBlock
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including only the package. #requires: and #includes:
			fields in the package are ignored.
	   If the spec is a project, answers an empty list.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"If there is no spec named <aString>, aBlock is evaluated"

	| pkgSpec |
	pkgSpec := self spec packageNamed: aString ifAbsent: aBlock.
	^pkgSpec resolveToPackagesIn: self spec visited: MetacelloVisitedPackages new! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/24/2009 19:45'!
projects
	"Answers the list of projects associated with this version"

	| projects |
	projects := OrderedCollection new.
	self spec projectDo: [:prj | projects add: prj projectReference ] packageDo: [:ignored | ] groupDo: [:ignored | ].
	^projects
! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/11/2010 10:07'!
record

	^self doRecordRequiredFromArray: self spec defaultPackageNames! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/11/2010 10:06'!
record: required

	^required recordRequiredForMetacelloMCVersion: self
! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/7/2010 08:11'!
repositoryOverrides: repositoriesCollection 

	self loaderPolicy overrideRepositories: repositoriesCollection! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 2/3/2010 15:43'!
resolveToLoadableSpecs: nameList
	"Resolves names in namelist to the  list of packages and projects in the version that would be loaded. Projects are 
	not traversed during the transitive closure. The scope is that of the version itself.
	   If the spec is a package, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer the project.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"

	^self spec resolveToLoadableSpecs: nameList! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/29/2010 15:32'!
silently: aBool 
	"by default silently is false"
	
	self loaderPolicy silently: aBool! !

AnObsoleteMetacelloProject subclass: #MetacelloMCProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Model'!

!MetacelloMCProject methodsFor: 'repository creation' stamp: 'dkh 10/22/2009 08:53'!
createRepository: aRepositorySpec

	^ MetacelloPlatform current createRepository: aRepositorySpec! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'DaleHenrichs 3/6/2010 07:46'!
defaultLoaderClass

	^MetacelloLoadingMCSpecLoader! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/7/2010 09:51'!
fetchProject
	"fetch the latest version of the configuration package"
	
	^self fetchProject: MetacelloLoaderPolicy new! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/7/2010 09:49'!
fetchProject: aLoaderPolicy
	"fetch the latest version of the configuration package"
	
	| mcLoader |
	(mcLoader := self loader) == nil
		ifTrue: [ mcLoader := self project loaderClass on: nil ].
	mcLoader loaderPolicy: aLoaderPolicy.
	mcLoader doingLoads: [ 
		MCWorkingCopy
			managersForClass: self configuration class
			do: [:mgr | | pkg |
				pkg := self packageSpec.
				mgr repositoryGroup repositories do: [:repo | pkg repositories repository: (repo asRepositorySpecFor: self) ].
				pkg name: mgr packageName.
				pkg fetchUsing: mcLoader.
				^true ]].
	^true
! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'dkh 4/17/2011 14:37'!
goferBranch: branchName project: commitMessage

	| pkgSpec |
	(pkgSpec := self projectPackage) == nil ifTrue: [ ^false ].
	pkgSpec file: pkgSpec name, '.', branchName.
	^pkgSpec goferBranchPackage: branchName message: commitMessage! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/15/2010 11:37'!
goferCommitProject: commitMessage

	| pkgSpec |
	(pkgSpec := self projectPackage) == nil ifTrue: [ ^false ].
	^pkgSpec goferCommitPackage: commitMessage! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:58'!
packageSpec

	^self packageSpecClass for: self! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:24'!
packageSpecClass

	^MetacelloPackageSpec! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'dkh 12/22/2009 10:00'!
packagesNeedSaving: aVersionString
	"Answer a collection of associations (package -> repository) representing the packages 
	 reachable from this project that need to be saved"

	| packages |
	packages := Set new.
	(self version: aVersionString) spec 
		packagesNeedSavingVisited: (Set with: self configuration class name asString)
		into: packages.
	^packages! !

!MetacelloMCProject methodsFor: 'private' stamp: 'dkh 6/10/2009 10:56'!
pragmaKeywords

	^super pragmaKeywords, #(projectPackage:attribute: packages:attribute: repositories:attribute: )! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 03/20/2010 12:48'!
projectPackage

	MCWorkingCopy
		managersForClass: self configuration class
		do: [:mgr | | pkgSpec repo |
			pkgSpec := 
				self packageSpec
					name: mgr packageName;
					yourself.
			mgr ancestors notEmpty
				ifTrue: [ pkgSpec file: mgr ancestors first name ].
			repo := mgr repositoryGroup repositories 
				detect: [:each | each ~~ MCCacheRepository default ] 
				ifNone: [ 
					Transcript cr; show: 'Using cache repository for ', self label, ' project package'.
					MCCacheRepository default ].
			pkgSpec repository: repo description.
			^pkgSpec].
	^nil! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'DaleHenrichs 10/27/2010 11:14'!
projectSpecClass

	^MetacelloMCProjectSpec! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 6/7/2009 10:11'!
repositoriesSpec

	^self repositoriesSpecClass for: self! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 6/7/2009 10:11'!
repositoriesSpecClass

	^MetacelloRepositoriesSpec! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:59'!
repositorySpec

	^self repositorySpecClass for: self! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:25'!
repositorySpecClass

	^MetacelloRepositorySpec! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'Dalehenrichs 02/10/2010 10:15'!
saveProject

	| pkgSpec |
	(pkgSpec := self projectPackage) == nil ifTrue: [ ^false ].
	^pkgSpec savePackage! !

!MetacelloMCProject methodsFor: 'repository updating' stamp: 'dkh 9/2/2009 06:21'!
updatePackageRepositoriesFor: versionString

	| versionSpec |
	(versionSpec := (self version: versionString) versionSpec) packageSpecsInLoadOrder do: [:pkgSpec |
		pkgSpec updatePackageRepositoriesFor: versionSpec ].
	^true! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/24/2010 15:50'!
updateProject
	"load the latest version of the configuration package"

	"WARNING: don't forget to refresh your project instance after doing an #updateProject, 
	 otherwise your instance won't reflect the info in the freshly loaded configuration"
	
	^self updateProject: MetacelloLoaderPolicy new! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'dkh 4/7/2011 23:26'!
updateProject: aLoaderPolicy
	"load the latest version of the configuration package"

	"WARNING: don't forget to refresh your project instance after doing an #updateProject, 
	 otherwise your instance won't reflect the info in the freshly loaded configuration"

	| mcLoader |
	(mcLoader := self loader) == nil
		ifTrue: [ mcLoader := self project loaderClass on: nil ].
	mcLoader loaderPolicy: aLoaderPolicy.
	mcLoader
		doingLoads: [ 
			MCWorkingCopy
				managersForClass: self configuration class
				do: [ :mgr | 
					| pkg ar |
					pkg := self packageSpec.
					mgr repositoryGroup repositories do: [ :repo | pkg repositories repository: (repo asRepositorySpecFor: self) ].
					ar := mgr metacelloPackageNameWithBranch.
					pkg name: (ar at: 1).
					(ar at: 2) notEmpty
						ifTrue: [ pkg file: (ar at: 2) ].
					pkg load.
					^ true ] ].
	^ true! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 6/6/2009 12:19'!
versionSpecClass

	^MetacelloMCVersionSpec! !

AnObsoleteMetacelloSpecLoader subclass: #MetacelloCommonMCSpecLoader
	instanceVariableNames: 'operator loaderPolicy disablePackageCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloCommonMCSpecLoader class methodsFor: 'utilities' stamp: 'dkh 9/10/2009 17:23'!
nameComponentsFrom: aVersionName
	| ar |
	ar := (aVersionName last isDigit and: [ (aVersionName indexOf: $.) > 0 ])ifFalse: [Array with: aVersionName with: '' with: 0 with: aVersionName with: self]
		ifTrue: [ | vrsn str |
			str := ((aVersionName copyAfterLast: $-) copyAfterLast: $.).
			vrsn := str isEmpty
				ifTrue: [0]
				ifFalse: [str asInteger].
			Array
				with: (aVersionName copyUpToLast:  $-)								"base pkg name"
				with: ((aVersionName copyAfterLast: $-) copyUpTo: $.)				"user"
				with:  vrsn "version"
				with: aVersionName
				with: self ].
	^ar! !

!MetacelloCommonMCSpecLoader methodsFor: 'versionInfo' stamp: 'dkh 3/20/2011 17:46'!
ancestorsFor: packageSpec

	| cacheKey vi |
	cacheKey := packageSpec file.
	^MetacelloPlatform current
		stackCacheFor: #ancestors
		at: cacheKey
		doing: [ :cache | 
			vi := packageSpec ancestors.
			cache at: cacheKey put: vi ].
! !

!MetacelloCommonMCSpecLoader methodsFor: 'versionInfo' stamp: 'DaleHenrichs 9/24/2010 14:47'!
currentVersionInfoFor: packageSpec

	| cacheKey vi |
	cacheKey := packageSpec file.
	^MetacelloPlatform current
		stackCacheFor: #currentVersionInfo
		at: cacheKey
		doing: [ :cache | 
			vi := packageSpec currentVersionInfo.
			cache at: cacheKey put: vi ].
! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 15:16'!
doLoad

	self subclassResponsibility! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'TestRunner 10/23/2009 11:33'!
doingLoads: aBlock
	"escape mechanism for recording and null loaders to skip doing loaderlike things"
	
	aBlock value! !

!MetacelloCommonMCSpecLoader methodsFor: 'testing' stamp: 'DaleHenrichs 3/11/2010 20:48'!
ensureForDevelopment

	^true! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:29'!
fetchingSpecLoader

	^self! !

!MetacelloCommonMCSpecLoader methodsFor: 'testing' stamp: 'DaleHenrichs 3/10/2010 14:40'!
hasRepositoryOverrides

	^self loaderPolicy hasRepositoryOverrides! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 4/12/2010 11:30'!
ignoreImage

	^self loaderPolicy ignoreImage! !

!MetacelloCommonMCSpecLoader methodsFor: 'initialize-release' stamp: 'DaleHenrichs 3/10/2010 14:41'!
initialize

	self loaderPolicy! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:17'!
linearLoadPackageSpec: packageSpec gofer: gofer

	self subclassResponsibility! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'dkh 4/6/2011 22:33'!
linearLoadPackageSpecs: packageSpecs repositories: repositories
	
	| gofer |
	gofer := MetacelloGofer new.
	repositories do: [:repo | gofer repository: repo ].
	packageSpecs do: [:pkg | pkg loadUsing: self gofer: gofer ].
! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 14:33'!
load
	| repos |
	repos := self repositoriesFrom: self spec repositorySpecs.
	^ self loadType == #atomic
		ifTrue: [self atomicLoadPackageSpecs: self spec packageSpecsInLoadOrder repositories: repos]
		ifFalse: ["assume #linear"
			self linearLoadPackageSpecs: self spec packageSpecsInLoadOrder repositories: repos ]
! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'dkh 4/6/2011 22:32'!
loadPackageDirective: aPackageLoadDirective gofer: aGofer

	| packageSpec |
	packageSpec := aPackageLoadDirective spec.
	MetacelloPlatform current
		do:  [ | loadBlock goferLoad answers resolvedReference |
			aGofer disablePackageCache. "for good luck:)"
			resolvedReference := self resolvePackageSpec: packageSpec gofer: aGofer.
			resolvedReference isNil ifTrue: [ "Package version already loaded into image" ^self ].
			loadBlock := [
				"mcLoader preLoad: packageSpec."
				goferLoad := MetacelloGoferLoad on: MetacelloGofer new.
				goferLoad addResolved: resolvedReference.
				goferLoad execute.
				MetacelloPlatform current clearCurrentVersionCache.
				"mcLoader postLoad: packageSpec" ].
			(answers := packageSpec answers) notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value].
			resolvedReference workingCopy repositoryGroup addRepository:  aPackageLoadDirective repository.
			Transcript cr; show: 'Loaded -> ', resolvedReference name, ' --- ', aPackageLoadDirective repository description, ' --- ', resolvedReference repository description  ]
		displaying: 'Loading ', packageSpec file! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:12'!
loadPackageDirectives: pkgLoads gofer: aGofer

	MetacelloPlatform current
		do:  [ | goferLoad loadBlock answers |
			goferLoad := MetacelloGoferLoad on: aGofer.
			answers := OrderedCollection new.
			pkgLoads do: [:packageLoadDirective | | resolvedReference |
				aGofer disablePackageCache. "for good luck:)"
				(resolvedReference := self 
						resolvePackageSpec: packageLoadDirective spec 
						gofer: aGofer) ~~ nil
					ifTrue: [ 
						goferLoad addResolved: resolvedReference.
						answers addAll: packageLoadDirective spec answers.
						packageLoadDirective resolvedReference:  resolvedReference ]].
			Transcript cr; show: 'Starting atomic load'.
			loadBlock := [
				"pkgLoads do: [:packageLoadDirective |  mcLoader preLoad: packageLoadDirective spec ]."
				goferLoad execute.
				pkgLoads do: [:packageLoadDirective |
					packageLoadDirective resolvedReference == nil
						ifTrue: [ Transcript cr; tab; show: 'Already Loaded -> ', packageLoadDirective file ]
						ifFalse: [ Transcript cr; tab; show: 'Loaded -> ', packageLoadDirective file, ' --- ',  packageLoadDirective repository description, ' --- ', packageLoadDirective resolvedReference repository description.
					packageLoadDirective resolvedReference workingCopy repositoryGroup addRepository: packageLoadDirective repository ]].
				MetacelloPlatform current clearCurrentVersionCache.
				"pkgLoads do: [:packageLoadDirective | 
					packageLoadDirective resolvedReference ~~ nil
						ifTrue: [mcLoader postLoad: packageLoadDirective spec ]]"].
			answers notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value].
			Transcript cr; show: 'Finished atomic load' ]
		displaying: 'Atomic Load...'.
! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:35'!
loaderPolicy

	loaderPolicy == nil ifTrue: [ loaderPolicy := MetacelloLoaderPolicy new ].
	^loaderPolicy! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:35'!
loaderPolicy: anObject
	loaderPolicy := anObject! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 07:43'!
loadingSpecLoader

	^self! !

!MetacelloCommonMCSpecLoader methodsFor: 'packages' stamp: 'dkh 07/22/2009 14:50'!
nameComponentsFrom: aVersionName

	^self class nameComponentsFrom: aVersionName! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'dkh 08/10/2009 15:06'!
operator

	operator == nil ifTrue: [ ^#= ].
	^operator! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'dkh 08/10/2009 15:06'!
operator: aSymbol

	operator := aSymbol! !

!MetacelloCommonMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 03/12/2010 16:43'!
postLoad: packageOrVersionSpec
	"subclassResponsibility, but it gets called during an upgrade, so leave it as NOOP"! !

!MetacelloCommonMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/10/2010 14:32'!
preLoad: packageOrVersionSpec

	self subclassResponsibility! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:37'!
recordingSpecLoader

	^(MetacelloNullRecordingMCSpecLoader on: self spec)
		shouldDisablePackageCache: self shouldDisablePackageCache;
		loaderPolicy: self loaderPolicy copy;
		yourself! !

!MetacelloCommonMCSpecLoader methodsFor: 'repositories' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoriesFrom: aMetacelloMVRepositorySpecs

	^self repositoriesFrom: aMetacelloMVRepositorySpecs ignoreOverrides: false! !

!MetacelloCommonMCSpecLoader methodsFor: 'repositories' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoriesFrom: aMetacelloMVRepositorySpecs ignoreOverrides: ignoreOverrides

	| repositories repos |
	(ignoreOverrides not and: [self hasRepositoryOverrides]) ifTrue: [ ^self loaderPolicy overrideRepositories ].
	repositories := MCRepositoryGroup default repositories.
	repos := OrderedCollection new.
	aMetacelloMVRepositorySpecs do: [:aSpec | | description repo |
		description := aSpec description.
		(repo := repositories detect: [:rep | rep description = description ] ifNone: [ aSpec createRepository ]) ~~ nil
			ifTrue: [ repos add: repo ]].
	^repos
! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:43'!
repositoryMap

	^self loaderPolicy repositoryMap! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'dkh 3/20/2011 17:49'!
resolvePackageSpec: packageSpec gofer: gofer

	|  references resolvedReference mcVersion loadedVersionInfos |
	references := self retryingResolvePackageSpecReferences: packageSpec gofer: gofer.
	resolvedReference := references last asMetacelloCachingResolvedReference.
	mcVersion := resolvedReference version.
	(loadedVersionInfos := self ancestorsFor: packageSpec) ~~ nil
		ifTrue: [ 
			loadedVersionInfos do: [:info | info name = mcVersion info name 
				ifTrue: [ 
					"package already loaded, don't load again"
					^nil ]]].
	^resolvedReference! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'dkh 4/6/2011 22:32'!
resolvePackageSpecReferences: packageSpec gofer: gofer

	|  versionReference references localGofer |
	localGofer := gofer.
	self hasRepositoryOverrides not
		ifTrue: [
			packageSpec repositorySpecs notEmpty
				ifTrue: [ 
					localGofer := MetacelloGofer new.
					(self repositoriesFrom: packageSpec repositorySpecs) do: [:repo | localGofer repository: repo ]]].
	(packageSpec getFile == nil or: [ self shouldDisablePackageCache ])
		ifTrue: [ 
			"don't use package-cache when trying to get latest version"
			localGofer disablePackageCache ].
	versionReference := packageSpec goferLoaderReference.
	references := versionReference resolveAllWith: localGofer.
	localGofer enablePackageCache.
	^references! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'dkh 4/26/2011 15:45'!
retryingResolvePackageSpecReferences: packageSpec gofer: gofer

	| retryCount references repositoryError |
	retryCount := 0.
	references := #().
	[references isEmpty
		and: [retryCount < 3]]
		whileTrue: [retryCount > 0
				ifTrue: [Transcript cr; show: '...RETRY->', packageSpec file ].
			references := [self resolvePackageSpecReferences: packageSpec gofer: gofer]
						on: Error , GoferRepositoryError
						do: [:ex | 
							retryCount >= 2
								ifTrue: [(ex isKindOf: GoferRepositoryError)
										ifTrue: [
											"ignore repository errors at this point, in case an alternate repository is in the list "
											Transcript cr; show: 'gofer repository error: ', ex description printString, '...ignoring'. 
											repositoryError := ex.
											ex resume: #()]
										ifFalse: [ex pass]].
							ex return: #()].
			retryCount := retryCount + 1].
	references isEmpty 
		ifTrue: [ | repositoryString |
			repositoryString := ''.
			gofer repositories do: [:repo | repositoryString := repositoryString, ' ', repo description ].
			Transcript cr; show: '...FAILED->', packageSpec file.
			self error: 'Could not resolve: ', packageSpec name, ' [', packageSpec file, ']', ' in', repositoryString,
				(repositoryError == nil 
					ifTrue: [''] 
					ifFalse: [
						"report repository error to user here, since failure here is likely to be due to earlier repository error"
						' ERROR: ', repositoryError description printString ]) ].
	^references! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:34'!
shouldDisablePackageCache

	disablePackageCache == nil ifTrue: [ disablePackageCache := false ].
	^ disablePackageCache! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:34'!
shouldDisablePackageCache: anObject
	disablePackageCache := anObject! !

MetacelloCommonMCSpecLoader subclass: #MetacelloFetchingMCSpecLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:33'!
actionLabel

	^'Fetching '! !

!MetacelloFetchingMCSpecLoader methodsFor: 'versionInfo' stamp: 'dkh 3/20/2011 17:51'!
ancestorsFor: packageSpec

	^self loadData
		ancestorsFor: packageSpec 
		ifAbsent: [ super ancestorsFor: packageSpec ]! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/9/2010 12:23'!
atomicLoadPackageSpecs: packageSpecs repositories: repositories

	self loaderPolicy 
		pushAtomicLoadDirectivesDuring: [ super linearLoadPackageSpecs: packageSpecs repositories: repositories ]
		for: self
! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:39'!
cacheRepository

	^self loaderPolicy cacheRepository! !

!MetacelloFetchingMCSpecLoader methodsFor: 'versionInfo' stamp: 'DaleHenrichs 3/10/2010 11:59'!
currentVersionInfoFor: packageSpec

	^self loadData
		currentVersionInfoFor: packageSpec 
		ifAbsent: [ super currentVersionInfoFor: packageSpec ]! !

!MetacelloFetchingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 16:42'!
doLoad

	self loaderPolicy copy load! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:40'!
ensuredMap

	^self loaderPolicy ensuredMap! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/21/2010 13:21'!
explicitLoadPackageSpecs: packageSpecs repositories: repositories
	
	| directive |
	directive := self loaderPolicy 
		pushExplicitLoadDirectivesDuring: [ super linearLoadPackageSpecs: packageSpecs repositories: repositories ]
		for: self.
	directive explicitLoadWithPolicy: self loaderPolicy.! !

!MetacelloFetchingMCSpecLoader methodsFor: 'actions' stamp: 'dkh 4/6/2011 23:48'!
linearLoadPackageSpec: packageSpec gofer: gofer

	MetacelloPlatform current
		do:  [ | references nearestReference cachedReference externalReference mcVersion loadedVersionInfos |
			"check to see if mcz file is already in cacheRepository"
			self flag: #cleanup. "validate the comment"
			"packageSpec name = 'OmniBrowser' ifTrue: [self halt: packageSpec file ]."
			cachedReference := self resolvePackageSpec: packageSpec cachedGofer: self loaderPolicy cacheGofer.
			(cachedReference ~~ nil and: [ packageSpec getFile ~~ nil ])
				ifTrue: [	 cachedReference name = packageSpec file ifTrue: [ ^self ]].
			"look up mcz file"
			references := self retryingResolvePackageSpecReferences: packageSpec gofer: gofer.
			nearestReference := references last asMetacelloCachingResolvedReference.
			"If the mcz is already in the cacheRepository, no need to copy"
			(cachedReference ~~ nil and: [ cachedReference name = nearestReference name ])
				ifTrue: [ ^self ].
			"If the mcz is already loaded into the image, no need to copy"
			(self ignoreImage not 
				and: [ (loadedVersionInfos := self ancestorsFor: packageSpec) ~~ nil ])
					ifTrue: [ loadedVersionInfos do: [:info | info name = nearestReference name ifTrue: [ ^self ]]].
			externalReference := (references select: [:ref | ref name = nearestReference name]) first asMetacelloCachingResolvedReference.
			self repositoryMap at: externalReference name put: externalReference repository.
			(self resolveDependencies: externalReference nearest: nearestReference into: (OrderedCollection with: nearestReference)) do: [:reference | | pSpec l |
				mcVersion := reference version.
				(l := (GoferVersionReference name: reference name) resolveAllWith: self loaderPolicy cacheGofer) isEmpty 
					ifTrue:  [ 
						self cacheRepository storeVersion: mcVersion.
				reference == nearestReference
					ifTrue: [ pSpec := packageSpec ]
					ifFalse: [ 
						pSpec :=  packageSpec project packageSpec.
						pSpec name: mcVersion info ].
				self loadData 
					addVersion: mcVersion 
					versionInfo: mcVersion info 
					resolvedReference: reference 
					packageSpec: pSpec ]].
			self loaderPolicy resetCacheGofer.
			self preLoad: packageSpec.
			(MetacelloDirective loadPackage: packageSpec externalReference: externalReference loader: self) addTo: self loadDirective.
			self postLoad: packageSpec.
			Transcript cr; show: 'Fetched -> ', externalReference name, ' --- ', externalReference repository description, ' --- ', nearestReference repository description ]
		displaying: 'Fetching ', packageSpec file! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/9/2010 12:39'!
linearLoadPackageSpecs: packageSpecs repositories: repositories
	
	self loaderPolicy 
		pushLinearLoadDirectivesDuring: [ super linearLoadPackageSpecs: packageSpecs repositories: repositories ]
		 for: self! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 11:58'!
loadData

	^self loaderPolicy loadData! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:36'!
loadDirective

	^self loaderPolicy loadDirective! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 10:25'!
loadingSpecLoader

	^(MetacelloLoadingMCSpecLoader on: self spec)
		shouldDisablePackageCache: self shouldDisablePackageCache;
		loaderPolicy: self loaderPolicy copy;
		yourself! !

!MetacelloFetchingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/11/2010 13:43'!
postLoad: packageOrVersionSpec

	(MetacelloDirective postLoadSpec: packageOrVersionSpec loader: self)  addTo: self loadDirective

! !

!MetacelloFetchingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/11/2010 13:43'!
preLoad: packageOrVersionSpec

	(MetacelloDirective preLoadSpec: packageOrVersionSpec loader: self) addTo: self loadDirective
! !

!MetacelloFetchingMCSpecLoader methodsFor: 'printing' stamp: 'DaleHenrichs 5/17/2010 16:42'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self loadDirective printOn: aStream.
	aStream nextPut: $)! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'dkh 4/10/2011 18:03'!
resolveDependencies: aResolvedReference nearest: nearestReference into: aCollection

	| block retryCount coll notDone |
	self flag: 'Not used, but retained to avoid upgrade issues'.
	block := [ :dependency | | reference |
		reference := MetacelloCachingGoferResolvedReference
			name: dependency versionInfo name
			repository: aResolvedReference repository.
		coll add: reference.
		Transcript cr; show: 'Fetched dependency -> ', reference name, ' --- ', reference repository description.
		self resolveDependencies: reference nearest: reference into: coll].
	retryCount := 0.
	notDone := true.
	coll := OrderedCollection new.
	[ notDone and: [ retryCount < 3 ]]
		whileTrue: [
			retryCount > 0 ifTrue: [ Transcript cr; show: '...RETRY' ].
			[ 	
				"ensure that all resolved references have cached their version while wrapped by error handler"
				aCollection do: [:each | each version ]. 
				nearestReference version dependencies do: block.
				notDone := false ]
					on: Error 
					do: [:ex | 
						retryCount := retryCount + 1.
						retryCount >= 3 ifTrue: [ ex pass ].
						coll := OrderedCollection new ]].
	aCollection addAll: coll.
	^aCollection! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/4/2010 19:29'!
resolvePackageSpec: packageSpec cachedGofer: gofer

	|  versionReference references |
	versionReference := packageSpec goferLoaderReference.
	(references := versionReference resolveAllWith: gofer) isEmpty 
		ifTrue: [ ^nil ].
	^references last asMetacelloCachingResolvedReference.
! !

MetacelloFetchingMCSpecLoader subclass: #MetacelloNullRecordingMCSpecLoader
	instanceVariableNames: 'afterLoads beforeLoads evalDoits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:33'!
actionLabel

	^'Recording '! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:50'!
afterLoads

	afterLoads == nil ifTrue: [ afterLoads := OrderedCollection new ].
	^afterLoads! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:50'!
beforeLoads

	beforeLoads == nil ifTrue: [ beforeLoads := OrderedCollection new ].
	^beforeLoads! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'versionInfo' stamp: 'dkh 08/10/2009 16:39'!
currentVersionInfoFor: packageSpec

	^self loadData
		currentVersionInfoFor: packageSpec 
		ifAbsent: [ nil ]
! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 14:46'!
doingLoads: aBlock
	"escape mechanism for recording and null loaders to skip doing loaderlike things"
! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'testing' stamp: 'DaleHenrichs 3/11/2010 17:18'!
ensureForDevelopment

	^false! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 15:43'!
evalDoits

	evalDoits == nil ifTrue: [ evalDoits := false ].
	^evalDoits ! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:46'!
evalDoits: aBool

	evalDoits := aBool! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:33'!
linearLoadPackageSpec: packageSpec gofer: gofer

	MetacelloPlatform current
		do:  [ | externalReference loadBlock answers fake |
			externalReference := self resolveRecordingPackageSpecReference: packageSpec gofer: gofer.
			loadBlock := [
					self preLoad: packageSpec.
					(MetacelloDirective 
						loadPackage: packageSpec 
						externalReference: externalReference 
						loader: self) addTo: self loadDirective.
					self postLoad: packageSpec ].
			(answers := packageSpec answers) notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value ].
			fake := packageSpec copy.
			fake name: fake file.
			self loadData 
				addVersion: fake
				versionInfo: fake
				resolvedReference: externalReference 
				packageSpec: packageSpec ]
		displaying: 'Recording ', packageSpec file! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:08'!
loadPackageDirective: aPackageLoadDirective gofer: aGofer
	"Noop"! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:12'!
loadPackageDirectives: pkgLoads gofer: aGofer
	"Noop"! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 13:45'!
loadedPackages

	| packages |
	packages := OrderedCollection new.
	self loadDirective packageDirectivesDo: [:directive | packages add: directive file ].
	^packages! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 4/21/2010 11:56'!
loadedRepositories

	| repos |
	repos := OrderedCollection new.
	self repositoryMap values collect: [:coll | repos addAll: coll ].
	^repos! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 4/9/2010 12:23'!
loadingSpecLoader

	^self! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 13:46'!
packages

	| packages |
	packages := OrderedCollection new.
	self loadDirective packageDirectivesDo: [:directive | packages add: directive spec ].
	^packages! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 4/8/2010 16:11'!
postLoad: packageOrVersionSpec

	self evalDoits ifFalse: [ ^self ].
	packageOrVersionSpec postLoadDoItBlock ~~ nil
		ifTrue: [ self afterLoads add: packageOrVersionSpec name, ' load' ].
	super postLoad: packageOrVersionSpec! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 4/8/2010 16:10'!
preLoad: packageOrVersionSpec

	self evalDoits ifFalse: [ ^self ].
	packageOrVersionSpec preLoadDoItBlock ~~ nil
		ifTrue: [ self beforeLoads add: packageOrVersionSpec name, ' load' ].
	super preLoad: packageOrVersionSpec! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 10:01'!
recordingSpecLoader

	^self! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'private' stamp: 'dkh 4/6/2011 22:35'!
resolvePackageSpecReferences: packageSpec gofer: gofer

	|  versionReference references localGofer |
	localGofer := gofer.
	self hasRepositoryOverrides not
		ifTrue: [
			packageSpec repositorySpecs notEmpty
				ifTrue: [ 
					localGofer := MetacelloGofer new.
					(self repositoriesFrom: packageSpec repositorySpecs) do: [:repo | localGofer repository: repo ]]].
	(packageSpec getFile == nil or: [ self shouldDisablePackageCache ])
		ifTrue: [ 
			"don't use package-cache when trying to get latest version"
			localGofer disablePackageCache ].
	versionReference := packageSpec goferLoaderReference.
	references := versionReference resolveAllWith: localGofer.
	localGofer enablePackageCache.
	^references! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 03/12/2010 15:01'!
resolveRecordingPackageSpecReference: packageSpec gofer: gofer

	| externalPackageReference |
	externalPackageReference := packageSpec file == nil
				ifTrue: [ GoferPackageReference name: packageSpec name ]
				ifFalse: [ GoferResolvedReference name: packageSpec file repository: nil ].
	packageSpec repositorySpecs isEmpty
		ifTrue: [  self repositoryMap at: externalPackageReference packageName put: (gofer repositories reject: [:repo | repo = MCCacheRepository default ]) ]
		ifFalse: [  self repositoryMap at: externalPackageReference packageName put: (packageSpec repositorySpecs collect: [:repoSpec | repoSpec createRepository ]) ].
	^externalPackageReference! !

MetacelloCommonMCSpecLoader subclass: #MetacelloLoadingMCSpecLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloLoadingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:33'!
actionLabel

	^'Loading '! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'dkh 4/6/2011 22:36'!
copySpec: pkgSpec from: repositorySpecs to: repository

	| gofer |
	gofer := MetacelloGofer new.
	(self repositoriesFrom: repositorySpecs) do: [:repo | gofer repository: repo ].
	^self copySpec: pkgSpec with: gofer to: repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 12/08/2010 11:06'!
copySpec: pkgSpec with: gofer to: aRepository

	| repository resolvedReference |
	[resolvedReference := pkgSpec goferLoaderReference resolveWith: gofer]
		on: Error
		do: [:ignored | ^nil ].
	repository := MCRepositoryGroup default repositories
		detect: [ :each | each = aRepository ]
		ifNone: [ aRepository ].
	repository storeVersion: resolvedReference version.
	^resolvedReference repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 15:16'!
doLoad
	"NOOP"! !

!MetacelloLoadingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:28'!
fetchingSpecLoader

	^(MetacelloFetchingMCSpecLoader on: self spec)
		shouldDisablePackageCache: self shouldDisablePackageCache;
		loaderPolicy: self loaderPolicy copy;
		yourself! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'dkh 4/17/2011 14:27'!
goferCommitBranchPackage: branchName using: repositorySpecs commitMessage: commitMessage
	| gofer repoSpecs wc |
	repoSpecs := self spec repositorySpecs notEmpty
		ifTrue: [ self spec repositorySpecs ]
		ifFalse: [ repositorySpecs ].
	gofer := MetacelloGofer new.
	gofer disablePackageCache.
	wc := self spec workingCopy.
	repositorySpecs
		do: [ :repoSpec | 
			| repo |
			repo := repoSpec createRepository.
			(wc possiblyNewerVersionsIn: repo) notEmpty
				ifTrue: [ 
					self
						notify:
							'There are possibly newer versions of the package ' , self spec name printString , ' in the repository '
								, repo description printString
								, '. Cancel and manually merge if you want to pick up the changes from the later version.' ].
			gofer repository: repo ].
	gofer package: self spec name.
	[ gofer interactiveCommit ]
		on: MCVersionNameAndMessageRequest
		do: [ :ex | 
			| ref |
			ref := GoferVersionReference name: ex suggestedName.
			ex
				resume:
					{(ref packageName , '.' , branchName , '-' , ref author , '.' , ref versionNumber printString).
					commitMessage} ].
	^ true! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'dkh 4/6/2011 22:35'!
goferCommitPackageUsing: repositorySpecs commitMessage: commitMessage

	| gofer repoSpecs wc |
	repoSpecs := self spec repositorySpecs notEmpty
				ifTrue: [ self spec repositorySpecs ]
				ifFalse: [ repositorySpecs ].
	gofer := MetacelloGofer new.
	gofer disablePackageCache.
	wc := self spec workingCopy.
	repositorySpecs do: [:repoSpec | | repo |
		repo := repoSpec createRepository.
		(wc possiblyNewerVersionsIn: repo) notEmpty
			ifTrue: [ self notify: 'There are possibly newer versions of the package ', self spec name printString, ' in the repository ', repo description printString, '. Cancel and manually merge if you want to pick up the changes from the later version.' ].
		gofer repository: repo ].
	gofer package: self spec name.
	gofer commit: commitMessage.
	^true! !

!MetacelloLoadingMCSpecLoader methodsFor: 'packages' stamp: 'dkh 4/6/2011 22:35'!
latestPackage: aString fromRepository: repositorySpecs

	| gofer |
	gofer := MetacelloGofer new.
	gofer disablePackageCache.
	(self repositoriesFrom: repositorySpecs) do: [:repo | gofer repository: repo ].
	^([(GoferPackageReference name: aString) resolveWith: gofer]
		on: Error
		do: [:ignored | ^ nil ]) name
! !

!MetacelloLoadingMCSpecLoader methodsFor: 'private' stamp: 'dkh 4/6/2011 22:36'!
linearLoadPackageSpec: packageSpec gofer: gofer

	MetacelloPlatform current
		do:  [ | loadBlock goferLoad answers resolvedReference repo |
			resolvedReference := self resolvePackageSpec: packageSpec gofer: gofer.
			resolvedReference isNil ifTrue: [ "Package version already loaded into image" ^self ].
			loadBlock := [
				self preLoad: packageSpec.
				goferLoad := MetacelloGoferLoad on: MetacelloGofer new.
				goferLoad addResolved: resolvedReference.
				goferLoad execute.
				MetacelloPlatform current clearCurrentVersionCache.
				self postLoad: packageSpec ].
			(answers := packageSpec answers) notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value].
			repo := resolvedReference repository.
			self hasRepositoryOverrides
				ifTrue: [
					repo := self loaderPolicy repositoryMap 
								at: resolvedReference name 
								ifAbsent: [ resolvedReference repository ].
					resolvedReference workingCopy repositoryGroup addRepository:  repo ]
				ifFalse: [ resolvedReference workingCopy repositoryGroup addRepository: resolvedReference repository ].
			Transcript cr; show: 'Loaded -> ', resolvedReference name, ' --- ', repo description, ' --- ', resolvedReference repository description  ]
		displaying: 'Loading ', packageSpec file! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/6/2010 09:04'!
packagesNeedSavingUsing: repositorySpecs into: aCollection

	| wc repoSpecs repo |
	(wc := self spec workingCopy) == nil ifTrue: [ ^self ].
	(wc ancestry ancestors notEmpty and: [ wc modified not])
		ifTrue: [ ^self ].
	repoSpecs := self spec repositorySpecs notEmpty
				ifTrue: [ self spec repositorySpecs ]
				ifFalse: [ repositorySpecs ].
	repo := (self spec getFile == nil or: [ wc ancestry ancestors isEmpty ])
		ifTrue: [ (self repositoriesFrom: repoSpecs ignoreOverrides: true) first ]
		ifFalse: [
			([ self resolveSpec: self spec from: repoSpecs ] 
				on: Error 
				do: [:ignored | ^self ]) repository ].
	aCollection add: self spec -> repo! !

!MetacelloLoadingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/10/2010 14:31'!
postLoad: packageOrVersionSpec

	| block |
	(block := packageOrVersionSpec postLoadDoItBlock) ~~ nil
		ifTrue: [ block valueWithPossibleArgs: { self. packageOrVersionSpec. } ]! !

!MetacelloLoadingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/10/2010 14:31'!
preLoad: packageOrVersionSpec

	| block |
	(block := packageOrVersionSpec preLoadDoItBlock) ~~ nil
		ifTrue: [ block valueWithPossibleArgs: { self. packageOrVersionSpec. } ]! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoryFor: pkgSpec from: repositorySpecs

	^([self resolveSpec: pkgSpec from: repositorySpecs]
		on: Error
		do: [:ignored | ^nil ]) repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoryFor: pkgSpec with: gofer

	^([self resolveSpec: pkgSpec with: gofer]
		on: Error
		do: [:ignored | ^nil ]) repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'dkh 4/6/2011 22:36'!
resolveSpec: pkgSpec from: repositorySpecs

	| gofer |
	gofer := MetacelloGofer new.
	gofer disablePackageCache.
	(self repositoriesFrom: repositorySpecs ignoreOverrides: true) 
		do: [:repo | gofer repository: repo ].
	^self resolveSpec: pkgSpec with: gofer! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:44'!
resolveSpec: pkgSpec with: gofer

	^pkgSpec goferLoaderReference resolveWith: gofer! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/6/2010 09:04'!
savePackageUsing: repositorySpecs

	| wc repo repoSpecs newVersion |
	(wc := self spec workingCopy) == nil ifTrue: [ ^false ].
	(wc ancestry ancestors notEmpty and: [ wc modified not])
		ifTrue: [ ^false ].
	repoSpecs := self spec repositorySpecs notEmpty
				ifTrue: [ self spec repositorySpecs ]
				ifFalse: [ repositorySpecs ].
	(self spec getFile == nil or: [ wc ancestry ancestors isEmpty ])
		ifTrue: [ repo := (self repositoriesFrom: repoSpecs ignoreOverrides: true) first ]
		ifFalse: [
			[ 	| newer |
				repo := (self resolveSpec: self spec from: repoSpecs) repository.
				newer := wc possiblyNewerVersionsIn: repo.
				newer isEmpty not 
					ifTrue: [
						(MetacelloPlatform current confirm: 'CAUTION!! These versions in the repository may be newer:', 
							String cr, newer printString, String cr,
							'Do you really want to save this version?') ifFalse: [ ^false ]] ] 
				on: Error 
				do: [:ignored | ^false ] ].
	(newVersion :=  wc newVersion) == nil ifTrue: [ ^false ].
	repo storeVersion: newVersion.
	^true! !
MetacelloPharoPlatform initialize!
